/* yacc gram.in */
#define SEOS	1
#define SCOMMENT	2
#define SLABEL	3
#define SUNKNOWN	4
#define SHOLLERITH	5
#define SICON	6
#define SRCON	7
#define SDCON	8
#define SBITCON	9
#define SOCTCON	10
#define SHEXCON	11
#define STRUE	12
#define SFALSE	13
#define SNAME	14
#define SNAMEEQ	15
#define SFIELD	16
#define SSCALE	17
#define SINCLUDE	18
#define SLET	19
#define SASSIGN	20
#define SAUTOMATIC	21
#define SBACKSPACE	22
#define SBLOCK	23
#define SCALL	24
#define SCHARACTER	25
#define SCLOSE	26
#define SCOMMON	27
#define SCOMPLEX	28
#define SCONTINUE	29
#define SDATA	30
#define SDCOMPLEX	31
#define SDIMENSION	32
#define SDO	33
#define SDOUBLE	34
#define SELSE	35
#define SELSEIF	36
#define SEND	37
#define SENDFILE	38
#define SENDIF	39
#define SENTRY	40
#define SEQUIV	41
#define SEXTERNAL	42
#define SFORMAT	43
#define SFUNCTION	44
#define SGOTO	45
#define SASGOTO	46
#define SCOMPGOTO	47
#define SARITHIF	48
#define SLOGIF	49
#define SIMPLICIT	50
#define SINQUIRE	51
#define SINTEGER	52
#define SINTRINSIC	53
#define SLOGICAL	54
#define SNAMELIST	55
#define SOPEN	56
#define SPARAM	57
#define SPAUSE	58
#define SPRINT	59
#define SPROGRAM	60
#define SPUNCH	61
#define SREAD	62
#define SREAL	63
#define SRETURN	64
#define SREWIND	65
#define SSAVE	66
#define SSTATIC	67
#define SSTOP	68
#define SSUBROUTINE	69
#define STHEN	70
#define STO	71
#define SUNDEFINED	72
#define SWRITE	73
#define SLPAR	74
#define SRPAR	75
#define SEQUALS	76
#define SCOLON	77
#define SCOMMA	78
#define SCURRENCY	79
#define SPLUS	80
#define SMINUS	81
#define SSTAR	82
#define SSLASH	83
#define SPOWER	84
#define SCONCAT	85
#define SAND	86
#define SOR	87
#define SNEQV	88
#define SEQV	89
#define SNOT	90
#define SEQ	91
#define SLT	92
#define SGT	93
#define SLE	94
#define SGE	95
#define SNE	96
#define SENDDO	97
#define SWHILE	98
#define SSLASHD	99
#line 123 "gram.in"

#include "defs.h"
#include "p1defs.h"

static int nstars;			/* Number of labels in an
					   alternate return CALL */
static int datagripe;
static int ndim;
static int vartype;
int new_dcl;
static ftnint varleng;
static struct Dims dims[MAXDIM+1];
extern struct Labelblock **labarray;	/* Labels in an alternate
						   return CALL */
extern int maxlablist;

/* The next two variables are used to verify that each statement might be reached
   during runtime.   lastwasbranch   is tested only in the defintion of the
   stat:   nonterminal. */

int lastwasbranch = NO;
static int thiswasbranch = NO;
extern ftnint yystno;
extern flag intonly;
static chainp datastack;
extern long laststfcn, thisstno;
extern int can_include;	/* for netlib */

ftnint convci();
Addrp nextdata();
expptr mklogcon(), mkaddcon(), mkrealcon(), mkstrcon(), mkbitcon();
expptr mkcxcon();
struct Listblock *mklist();
struct Listblock *mklist();
struct Impldoblock *mkiodo();
Extsym *comblock();
#define ESNULL (Extsym *)0
#define NPNULL (Namep)0
#define LBNULL (struct Listblock *)0
extern void freetemps(), make_param();

 static void
pop_datastack() {
	chainp d0 = datastack;
	if (d0->datap)
		curdtp = (chainp)d0->datap;
	datastack = d0->nextp;
	d0->nextp = 0;
	frchain(&d0);
	}

typedef union {
	int ival;
	ftnint lval;
	char *charpval;
	chainp chval;
	tagptr tagval;
	expptr expval;
	struct Labelblock *labval;
	struct Nameblock *namval;
	struct Eqvchain *eqvval;
	Extsym *extval;
	} YYSTYPE;
extern int yychar, yyerrflag;
extern YYSTYPE yyval;
extern YYSTYPE yylval;
static short yydef[] = {
	  -1,  100,  100,  100,  100,   53,  100,  100,  100,  100, 
	 100,  100,   41,  100,  100,  100,  100,  100,  100,  100, 
	 100,  151,  151,  151,  151,    8,  151,    6,  294,  295, 
	  -5,  297,  298,  299,  -13,  301,  -21,  222,  222,  222, 
	 100,   64,   64,   64,   52,   48,   47,  -25,   30,  -39, 
	 -43,  -47,  -51,    7,  156,  176,  282,  176,  -59,  222, 
	 -63,  -67,   64,  -73,  289,   58,  -79,  -85,   55,   49, 
	  37,   55,  -89,  -95,  292,  290,   11,   10, -101,   10, 
	 151, -105, -109,    3,   28,   22,  268,   56,   50,   51, 
	  38,   36,   35,   34,   33, -113, -127,   15,  268,   40, 
	  98, -135, -143, -147, -153,   29,   27,   26,   25,   24, 
	-159,   21,   20,   19,   18, -173, -179,   55, -185,   31, 
	 291, -189,   12,   13,  251,   10,  302,   30, -195, -199, 
	  17,  268,   39,   44,  174,  293,   98,    9, -203,   43, 
	  45,  293
};
static short yyex[] = {
	   0,    0,   -1,    1,    1,  296,   14,  291,   74,  291, 
	  -1,    1,    1,  300,   83,  291,   85,  291,   -1,    1, 
	  14,  291,   -1,    1,   80,  274,   81,  274,   82,  274, 
	  83,  274,   84,  274,   85,  274,   -1,   54,    1,   46, 
	  -1,  274,    1,   32,   -1,    1,    1,   32,   -1,    1, 
	   6,   99,   14,  291,   98,  291,   -1,    1,    1,    5, 
	  -1,    1,    1,    4,   -1,    1,    1,    4,   74,    4, 
	  -1,    1,    1,   64,   78,   64,   -1,    1,    1,   62, 
	  78,   62,   -1,  269,    1,   57,   -1,  268,   75,   14, 
	  77,   32,   -1,    1,    1,   42,   74,  291,   -1,    1, 
	  14,  291,   -1,    1,    1,    5,   -1,    1,    1,    5, 
	  -1,    1,   80,  127,   81,  127,   82,  127,   83,  127, 
	  84,  127,   85,  127,   -1,   85,   75,   16,   77,  292, 
	  78,   16,   -1,    1,    1,    8,   78,    8,   99,    8, 
	  -1,    1,    1,    5,   -1,    1,    1,   61,   78,   61, 
	  -1,  268,    1,   60,   78,   60,   -1,  268,   91,    1, 
	  92,    1,   93,    1,   94,    1,   95,    1,   96,    1, 
	  -1,   23,    1,   63,   78,   63,   -1,  150,    1,   59, 
	  78,   59,   -1,  268,   75,   32,   -1,    1,   14,  291, 
	  98,  291,   -1,    1,   78,   59,   -1,  268,   77,   32, 
	  -1,    1,    1,    8,   78,    8,   99,    8,   -1,    1
};
static short yyact[] = {
	-482, -483,  256,    3, -484, -307, -362,  -16, -448, -345, 
	 -39,   -7, -451, -340,  -25, -455,  -15, -431, -453, -449, 
	 -21, -454,  -19,  -20,  -41, -343,  -18, -308,  -22,  -24, 
	-465, -475,  -10,   -9,   -8,  -14,  -17, -404, -342, -457, 
	 -23, -452, -519, -341,  -27, -355, -353,  -40,   -3, -456, 
	 -12, -344,  -28, -447, -354,  -38, -450,   -2, -377,   97, 
	  73,   72,   69,   68,   67,   66,   65,   64,   63,   62, 
	  60,   59,   58,   57,   56,   55,   54,   53,   52,   51, 
	  50,   49,   48,   47,   46,   45,   44,   43,   42,   41, 
	  40,   39,   38,   37,   36,   35,   34,   33,   32,   31, 
	  30,   29,   28,   27,   26,   25,   24,   23,   22,   21, 
	  20,   19,   18,    4, -490,    1, -305,   78, -304,   74, 
	-388, -387, -386, -385, -381, -382, -383, -390, -389, -473, 
	-301, -402, -401, -339,   82,   81,   80,   74,   14,   13, 
	  12,   11,   10,    9,    8,    7,    6,    5, -388, -387, 
	-386, -385, -381, -382, -383, -390, -389, -473, -301, -402, 
	-401, -349, -348,   84,   82,   81,   80,   74,   14,   13, 
	  12,   11,   10,    9,    8,    7,    6,    5, -296,   74, 
	-473,   14, -362,  -16, -345,   -7, -340,  -15, -343,  -10, 
	  -9,   -8,  -14, -342, -341, -355, -353,   -3,  -12, -344, 
	-354, -531,   -2,   73,   70,   68,   65,   64,   62,   59, 
	  58,   56,   51,   48,   47,   46,   45,   38,   29,   26, 
	  24,   22,   20,   19, -352,   82, -473, -285, -440,   85, 
	  83,   14, -284,   83,  -55,   78, -535,   78, -283,   78, 
	-282,   78, -281,   78,  -57,   78, -279,  -58,   99,   78, 
	 -60, -535,   78,   44, -466,    5, -388, -387, -386, -385, 
	-381, -382, -383, -390, -389, -473, -275, -402, -401,  -63, 
	  82,   81,   80,   74,   14,   13,   12,   11,   10,    9, 
	   8,    7,    6,    5, -388, -387, -386, -385, -381, -382, 
	-383, -390, -389, -473, -271, -402, -401, -274,   90,   81, 
	  80,   74,   14,   13,   12,   11,   10,    9,    8,    7, 
	   6,    5, -388, -387, -386, -385, -381, -382, -383, -390, 
	-389, -473, -332, -275, -402, -401, -336, -335,   84,   82, 
	  81,   80,   74,   15,   14,   13,   12,   11,   10,    9, 
	   8,    7,    6,    5, -268,   78, -473, -267, -266,   78, 
	  74,   14, -388, -387, -386, -385, -381, -382, -383, -390, 
	-389, -473, -275, -402, -401,   81,   80,   74,   14,   13, 
	  12,   11,   10,    9,    8,    7,    6,    5, -402, -401, 
	-262, -263, -264, -265,   85,   84,   83,   82,   81,   80, 
	 -73,   74, -260,   74, -411,    6, -388, -387, -386, -385, 
	-381, -382, -383, -390, -389, -473, -259, -402, -401, -274, 
	  90,   81,   80,   74,   14,   13,   12,   11,   10,    9, 
	   8,    7,    6,    5, -388, -387, -386, -385, -381, -382, 
	-383, -390, -389, -473, -259, -367, -402, -401, -258, -274, 
	  90,   82,   81,   80,   75,   74,   14,   13,   12,   11, 
	  10,    9,    8,    7,    6,    5, -256,   74, -363,    6, 
	-254,   76, -253,   74, -252,   74, -247,   74, -244,   74, 
	-243,   14, -242,   78, -285, -440,   85,   83, -240,   74, 
	-237,   78, -236,   78, -402, -401, -227, -228, -229, -235, 
	-234, -233, -232, -231, -400, -398, -399, -396, -397, -395, 
	  96,   95,   94,   93,   92,   91,   89,   88,   87,   86, 
	  85,   84,   83,   82,   81,   80, -222,   78, -388, -387, 
	-386, -385, -381, -382, -383, -390, -389, -473, -259, -402, 
	-401, -334, -333, -274,   90,   84,   82,   81,   80,   74, 
	  14,   13,   12,   11,   10,    9,    8,    7,    6,    5, 
	-337, -221,   78,   75, -338, -402, -401, -262, -263, -264, 
	-265,   85,   84,   83,   82,   81,   80,   75, -473, -267, 
	  74,   14, -219,   78, -264,   84,  -96, -402, -401, -262, 
	-263, -264, -265,   85,   84,   83,   82,   81,   80,   75, 
	-366, -213,   78,   75, -211,   71, -473, -208,   98,   14, 
	-448, -451, -455, -453, -449, -454, -457, -452, -456, -447, 
	-450,   72,   67,   63,   54,   52,   34,   32,   31,   28, 
	  25,   21, -206,   74, -473, -205,   74,   14, -417,   74, 
	-388, -387, -386, -385, -381, -382, -383, -390, -389, -473, 
	-202, -402, -401, -274,   90,   81,   80,   74,   14,   13, 
	  12,   11,   10,    9,    8,    7,    6,    5, -439,   83, 
	-199,   83, -473, -472, -467,   82,   75,   14, -194,   74, 
	-380, -402, -401, -262, -263, -264, -265,   85,   84,   83, 
	  82,   81,   80,   75, -402, -401, -227, -228, -229, -235, 
	-400, -398, -399, -396, -397, -395,   96,   95,   94,   93, 
	  92,   91,   85,   84,   83,   82,   81,   80, -229,   84, 
	-193,   78, -192,   78, -116, -402, -401, -227, -228, -229, 
	-235, -234, -233, -232, -231, -400, -398, -399, -396, -397, 
	-395,   96,   95,   94,   93,   92,   91,   89,   88,   87, 
	  86,   85,   84,   83,   82,   81,   80,   75, -191,   78, 
	-190,   78, -402, -401, -262, -263, -264,   84,   83,   82, 
	  81,   80, -262, -263, -264,   84,   83,   82, -119,   77, 
	-120,   75, -189,   78, -121, -188,   78,   75, -187,   74, 
	-403, -402, -401, -227, -228, -229, -235, -234, -233, -232, 
	-231, -400, -398, -399, -396, -397, -395,   96,   95,   94, 
	  93,   92,   91,   89,   88,   87,   86,   85,   84,   83, 
	  82,   81,   80,   75, -186,   78, -388, -387, -386, -385, 
	-381, -382, -383, -390, -389, -473, -259, -402, -401, -258, 
	-274,   90,   82,   81,   80,   74,   14,   13,   12,   11, 
	  10,    9,    8,    7,    6,    5, -185, -402, -401, -227, 
	-228, -229, -235, -234, -233, -232, -231, -400, -398, -399, 
	-396, -397, -395,   96,   95,   94,   93,   92,   91,   89, 
	  88,   87,   86,   85,   84,   83,   82,   81,   80,   75, 
	-372, -402, -401, -227, -228, -229, -235, -234, -233, -232, 
	-231, -400, -398, -399, -396, -397, -395,   96,   95,   94, 
	  93,   92,   91,   89,   88,   87,   86,   85,   84,   83, 
	  82,   81,   80,   75, -184, -402, -401, -227, -228, -229, 
	-235, -234, -233, -232, -231, -400, -398, -399, -396, -397, 
	-395,   96,   95,   94,   93,   92,   91,   89,   88,   87, 
	  86,   85,   84,   83,   82,   81,   80,   75, -183,   74, 
	-182,   76, -407,   14, -179, -428,   83,   78, -434, -178, 
	  78,   75, -388, -387, -386, -385, -381, -382, -383, -390, 
	-389, -473, -259, -402, -401, -175, -274,   90,   82,   81, 
	  80,   74,   14,   13,   12,   11,   10,    9,    8,    7, 
	   6,    5, -174,   76, -464, -173,   78,   75, -388, -387, 
	-386, -385, -381, -382, -383, -390, -389, -473, -172, -402, 
	-401,   81,   80,   74,   14,   13,   12,   11,   10,    9, 
	   8,    7,    6,    5, -170, -461,   99,   78, -471, -169, 
	  78,   75, -127, -493,   75,   14, -402, -401, -227, -228, 
	-229,   84,   83,   82,   81,   80, -402, -401, -227, -228, 
	-229, -235, -234, -400, -398, -399, -396, -397, -395,   96, 
	  95,   94,   93,   92,   91,   86,   85,   84,   83,   82, 
	  81,   80, -402, -401, -227, -228, -229, -235, -234, -233, 
	-400, -398, -399, -396, -397, -395,   96,   95,   94,   93, 
	  92,   91,   87,   86,   85,   84,   83,   82,   81,   80, 
	-402, -401, -227, -228, -229, -235,   85,   84,   83,   82, 
	  81,   80, -227, -228, -229,   84,   83,   82, -130,   74, 
	-375,   70, -157,   81, -515, -156,   78,   75, -155,   78, 
	-388, -387, -386, -385, -381, -382, -383, -390, -389, -473, 
	-259, -402, -401, -414, -274,   90,   82,   81,   80,   74, 
	  14,   13,   12,   11,   10,    9,    8,    7,    6,    5, 
	-511, -154,   78,   75, -137,   75, -153,   78, -388, -387, 
	-386, -385, -381, -382, -383, -390, -389, -473,   14,   13, 
	  12,   11,   10,    9,    8,    7,    6,    5, -152,   82, 
	-473, -467,   82,   14, -151,   76, -494, -150,   78,   75, 
	-318,   75,  -73, -182,   76,   74, -319,   75, -320,   75, 
	-384,   75, -324,   75, -392,   75, -360, -188,   78,   75, 
	-149,   78, -371, -402, -401, -227, -228, -229, -235, -234, 
	-233, -232, -231, -400, -398, -399, -396, -397, -395,   96, 
	  95,   94,   93,   92,   91,   89,   88,   87,   86,   85, 
	  84,   83,   82,   81,   80,   75, -148,   78, -145, -402, 
	-401, -227, -228, -229, -235, -234, -233, -232, -231, -400, 
	-398, -399, -396, -397, -395,   96,   95,   94,   93,   92, 
	  91,   89,   88,   87,   86,   85,   84,   83,   82,   81, 
	  80,   77, -497,   14, -127,   14, -420,   75, -170, -430, 
	  83,   78, -143,   78,   -1
};
static short yypact[] = {
	   2,  116,  116,  116,  116,  117,  178,  178,  178,  178, 
	 178,  178,  179,  180,  180,  180,  182,  182,  182,  182, 
	 224,  224,  224,  224,  224,  225,  226,  229,  233,  235, 
	 237,  239,  241,  243,  245,  248,  252,  254,  254,  254, 
	 254,  284,  284,  284,  298,  345,  349,  390,  391,  392, 
	 410,  410,  237,  473,  474,  474,  181,  478,  479,  480, 
	 181,  181,  480,  384,  481,  483,  516,  517,  561,  573, 
	 575,  583,  410,  237,  500,  500,  623,  629,  237,  629, 
	 668,  479,  479,  669,  696,  709,  749,  500,  573,  573, 
	 757,  575,  575,  575,  765,  768,  500,  773,  815,  500, 
	 500,  225,  479, 1036, 1036, 1041,  696, 1059, 1086, 1086, 
	1106,  709,  709,  709, 1115, 1118, 1118,  384,  410, 1119, 
	 237,  237, 1123, 1167, 1189,  629, 1195, 1204, 1211,  410, 
	 500, 1211, 1257,  500, 1258, 1275, 1292,  500,  225,  500, 
	 500,  500,  395, 1303, 1145, 1300, 1297,  410,  395, 1295, 
	1293, 1011,  181, 1145,  626,  953,  953,  598, 1239, 1221, 
	1218,  410, 1215, 1213, 1209, 1207, 1201, 1198, 1192, 1011, 
	1178,  410,  181,  410, 1165, 1162, 1145,  181,  626, 1129, 
	1126,  410,  410, 1121,  395,  410,  395,  395,  410,  570, 
	 298,  298,  298, 1034, 1030, 1026, 1011,  181,  181,  996, 
	 993,  977,  960,  956,  626,  953,  951,  949,  931,  897, 
	 181,  863,  831,  797,  779,  776,  771,  769,  570,  751, 
	 328,  298,  731,  713,  711,  410,  410,  410,  410,  410, 
	 410,  410,  410,  410,  410,  298,  298,  677,  181,  665, 
	 661,  229,  659,  181,  644,  181,  181,  626,  611,  395, 
	 598,  410,  410,  410,  595,  410,  592,  395,  410,  395, 
	 365,  365,  365,  365,  365,  570,  570,  570,  552,  534, 
	 298,  500,  410,  410,  365,  181,  181,  181,  181,  476, 
	 181,  181,  467,  181,  471,  469,  229,  181,  181,  467, 
	 465,  463,  461,  459,  457,  440,  395,  181,  393,  181, 
	 328,  384,  365,  328,  298,  270,  255,  181,  203,  181, 
	 163,  119,  134,  119,  115,   59
};
static short yygo[] = {
	  -1, -316, -368, -144, -160, -412, -351, -356, -361, -413, 
	 296,  257,  249,  187,  184,  148,  142, -255, -323, -322, 
	-321, -323, -322, -321, -224,  -66,  270,  236,  235,  221, 
	 192,  191,  190, -326, -326, -327,  218,  189, -516,  -37, 
	 248,  -26, -458,  -36, -408, -123,  156, -261, -261, -261, 
	-261, -226, -226, -226, -226, -226, -261, -261, -261, -261, 
	-261, -226, -226, -226, -226, -226, -226, -226, -226, -226, 
	-226, -226, -226, -226, -261, -226, -226, -226, -226, -226, 
	-226, -226, -171, -226, -171, -171, -226, -226, -226, -226, 
	-303, -226, -261, -303, -303, -303, -303, -303, -226, -303, 
	-303, -261, -303, -303, -303, -303, -303, -273,  312,  310, 
	 305,  303,  302,  301,  300,  274,  271,  264,  263,  262, 
	 261,  260,  237,  222,  220,  213,  211,  209,  208,  196, 
	 169,  158,  151,  141,  140,  139,  137,  135,  133,  130, 
	 117,  114,  113,  112,  111,  110,  109,  108,  107,  106, 
	 105,  100,   99,   96,   94,   93,   92,   91,   90,   87, 
	  85,   84,   75,   74,   71,   70,   68,   63, -230,  -11, 
	-270, -462, -463, -459,  138,  101, -486, -418, -418, -419, 
	 178,  154, -180, -204,  204, -124, -217,  -98, -147, -164, 
	-165, -166, -167, -532,  192,  191,  190,  189,  154, -379, 
	-378,  157, -257, -478, -479, -477, -476,  102,   82,   81, 
	-195, -133,  -90, -220,  -89,  -70,  267,  266,  265, -347, 
	-346,   44, -225,  -65,  270, -393, -394,  119, -423,  -78, 
	-474, -474, -391, -405, -128, -207, -468, -391, -391, -201, 
	-128, -128, -128, -128, -391,  -78, -406, -370, -474, -468, 
	-423, -201,  -78, -207, -474, -474,  -81,  -80, -437, -435, 
	-241,  -78, -438, -436,  -74, -359, -474,  -49,  307,  299, 
	 297,  288,  287,  286,  283,  281,  280,  278,  277,  276, 
	 275,  250,  245,  243,  241,  239,  238,  210,  198,  197, 
	 196,  192,  191,  190,  189,  172,  170,  169,  168,  157, 
	 154,  152,  151,   61,   60,   56,   27, -469, -470,  168, 
	 -13, -441, -442, -443, -444,  245,  197,   56, -325, -421, 
	-432, -421, -325, -421, -325, -528, -433, -421, -528, -528, 
	-528, -528, -528, -325, -325, -325, -528, -528, -528, -528, 
	-528, -293, -528, -528, -523,  312,  310,  309,  305,  303, 
	 302,  300,  274,  267,  266,  265,  264,  263,  262,  261, 
	 260,  247,  246,  220,  218,  204,  189,  178,  177,  154, 
	  46,  -75,  -75,  -97,  -75,  -75, -142, -141, -136, -140, 
	-138, -136, -134, -159, -131, -214,  -76, -115, -114, -113, 
	-112, -111, -110, -109, -108, -107, -106, -101, -209, -210, 
	-100, -212, -214,  -88, -223,  -86,  -85,  -76, -272,  295, 
	 273,  272,  270,  269,  258,  255,  253,  252,  251,  244, 
	 234,  233,  232,  231,  230,  229,  228,  227,  226,  225, 
	 212,  201,  188,  182,  181,  176,  173,  161,  153,  147, 
	 144,  129,  118,   72,   51,   50,  -68,  -99, -132, -129, 
	-105, -104,  -99, -117, -105, -104,  -99,  -87,  -68, -521, 
	 304,  270,  258,  236,  235,  221,  201,  192,  191,  190, 
	 185,  171,   44, -364, -365, -163, -218,  118,   51,   50, 
	-118,  -95,  -94,  -93,  -92,  -91, -238,  -72,  -71,  -69, 
	 -64, -302,  305,  303,  302,  300,  274,  264,  263,  262, 
	 261,  260,  220,  -50,  -48, -527,  312,  310, -415, -416, 
	 144, -504, -424, -125,  170,  151, -425, -426,  151, -357, 
	-358,  212,  -67, -505, -505,  -67,  -67,  -67, -505,  -67, 
	 -67,  -67,  -67,  -67, -522,  304,  270,  236,  235,  221, 
	 196,  192,  191,  190,  169,  151,   44, -525, -525, -525, 
	-525, -529, -529, -529, -529, -529, -529, -529, -529, -529, 
	-529, -529, -529, -529, -524,  312,  310,  305,  303,  302, 
	 300,  274,  264,  263,  262,  261,  260,  220,  196,  170, 
	 169,  151, -526,  -35,  -79, -246, -508,  286,  279, -103, 
	 -83,  -82,  -59, -492,  307,  276,  275,  238,  -84, -480, 
	  61, -203, -315, -488, -491, -487, -317,  -42,  -43,  -44, 
	-300, -299, -298, -297,  -51,  -52, -295, -533, -294, -292, 
	-373, -374, -291,  -53, -485, -306,   40,   20,   19,   18, 
	  17,   16,   15,   14,   13,   11,   10,    9,    8,    7, 
	   6,    4,    3,    2,    1, -276,  -61,  -62, -239, -277, 
	  59,   39,   38,   37, -481, -168, -496, -495,  149,  -34, 
	 -33,  -32,  -31,  -30,  -29,  -54, -290, -289, -288, -287, 
	-286, -460, -409,   80,   26,   24,   23,   22,   21, -200, 
	-280, -278, -251, -215, -198, -162, -158,  -56,  121,  120, 
	  78,   73,   52,   36,   34, -126, -102, -139, -422,  125, 
	  79, -427, -248,   57, -146, -196,  134, -245, -250,  351, 
	-446, -445, -122,  136,  100, -499, -498,  282, -429, -501, 
	-500,   55, -135, -197, -503, -502,  169, -507, -506,  241, 
	-510, -509,  172, -176, -177, -513, -512,  153, -161, -216, 
	 186, -514, -410,   54,  -77, -181, -249, -518, -517,  155, 
	-520, -376, -530,  308, -309, -310, -534, -369, -350, -311, 
	-536, -537,  -47,  -45,  312,  311,  310, -312, -313,  -46, 
	-314,   -6,   -5, -331, -539, -538, -328, -329, -330,   63, 
	  62,   43,   42,   41,   -4, -269, -541, -540,  220,   -1
};
static short yypgo[] = {
	   0,    0,    0,  603,  599,  206,  604,  604,  173,  731, 
	 698,  742,  748,  750,  186,  186,  187,  187,  459,  459, 
	 459,  459,  459,  459,  459,  459,  459,  459,  459,  459, 
	 344,  344,  476,  505,  505,  505,  505,  505,  505,  193, 
	 752,  752,  756,  756,  211,  211,  758,  758,  758,  758, 
	 758,  758,  758,  758,  769,  787,  787,  220,  220,  223, 
	 223,  223,   25,   25,  778,   25,   25,   25,  223,  223, 
	 223,   35,   35,  215,  215,  771,  771,  770,  768,  170, 
	 787,  787,  787,  787,  763,  763,  769,  784,  784,  784, 
	 772,  772,  772,  758,  758,  758,  758,  757,  712,  708, 
	 625,  169,  169,  520,  202,  202,  310,  756,  756,  755, 
	  17,  752,  752,  752,  752,  752,  752,  752,  200,  754, 
	 605,  605,  605,  605,  605,  605,  605,  491,  582,  582, 
	 582,  534,  564,  564,  564,  564,  564,  564,  513,  226, 
	 344,  344,  168,  168,  168,  168,  168,  168,  107,  107, 
	 408,  672,  185,  185,   45,  748,  746,  663,    9,  739, 
	 739,  509,  736,  736,  734,  183,  183,  179,  179,  314, 
	 728,  517,  725,  725,  723,  722,  702,  720,  718,  601, 
	 601,  716,  660,  660,  659,  659,  586,  586,  583,  583, 
	 583,  583,  173,  173,   42,   42,   42,   42,   42,   42, 
	  42,   42,   42,   42,   42,   41,   39,  695,   43,   43, 
	  43,  604,  604,  176,  308,  308,  210,  210,  206,  206, 
	 267,  593,  649,  603,  603,  603,  603,  603,  603,    1, 
	 602,  602,  602,  602,  602,  602,    0,    0,  602,  599, 
	 654,  654,  655,  655,  657,  661,  661,  662,  662,  705, 
	 705,  517,  517,  665,  665,  728,  679,  679,  698,  733, 
	 733,  663,  742,  744,  745,  745,  664,  664,  408,  408, 
	 459,  459,  513,  564,  491,  505,  505,  605,  605,  200, 
	 752,  752,  687,  758,  758,  759,  767,  785,  785,  220, 
	 520,  687,  476,  509,  604,  604,  604,  604,  604,  604, 
	 604,  604,  657,    0
};
static short yyrlen[] = {
	   0,    0,    0,    3,    0,    0,    1,    2,    0,    3, 
	   0,    1,    1,    4,    0,    1,    1,    3,    3,    3, 
	   3,    3,    2,    3,    3,    3,    3,    3,    2,    3, 
	   1,    4,    0,    3,    3,    3,    3,    2,    3,    3, 
	   4,    1,    3,    7,    1,    3,    2,    2,    2,    3, 
	   4,    4,    2,    1,    1,    1,    2,    1,    1,    3, 
	   3,    3,    1,    3,    0,    5,    5,    5,    3,    3, 
	   3,    5,    1,    3,    1,    4,    4,    3,    3,    1, 
	   2,    2,    1,    1,    3,    3,    1,    1,    1,    1, 
	   1,    1,    1,    3,    3,    2,    2,    1,    0,    0, 
	   0,    1,    1,    2,    3,    1,    3,    7,    3,    1, 
	   1,    3,    3,    4,    3,   10,    1,    5,    4,    5, 
	   2,    2,    6,    2,    1,    4,    7,    3,    1,    1, 
	   1,    5,    1,    1,    1,    1,    1,    1,    1,    5, 
	   5,    2,    1,    1,    1,    1,    1,    1,    1,    1, 
	   3,    0,    3,    1,    1,    3,    0,    3,    1,    3, 
	   1,    1,    3,    1,    0,    3,    1,    5,    1,    2, 
	   1,    2,    3,    1,    0,    0,    0,    6,    0,    3, 
	   1,    3,    3,    3,    3,    3,    3,    1,    3,    5, 
	   4,    3,    6,    4,    1,    1,    1,    1,    1,    1, 
	   1,    1,    1,    1,    1,    1,    2,    0,    5,    5, 
	   7,    5,    1,    1,    1,    1,    3,    1,    3,    2, 
	   1,    1,    0,    3,    5,    4,    4,    3,    4,    1, 
	   1,    2,    3,    3,    2,    2,    0,    3,    2,    1, 
	   2,    3,    1,    3,    3,    3,    3,    3,    3,    2, 
	   3,    1,    1,    1,    3,    1,    1,    3,    3,    2, 
	   3,    3,    4,    2,    1,    3,    1,    2,    1,    1, 
	   1,    1,    1,    1,    1,    1,    1,    1,    2,    1, 
	   2,    1,    1,    2,    2,    3,    3,    1,    3,    1, 
	   1,    0,    1,    1,    1,    1,    1,    1,    1,    1, 
	   1,    1,    1,    2
};
#define YYS0	488
#define YYDELTA	252
#define YYNPACT	316
#define YYNDEF	142

#define YYr301	0
#define YYr302	1
#define YYr303	2
#define YYr11	3
#define YYr21	4
#define YYr29	5
#define YYr45	6
#define YYr46	7
#define YYr66	8
#define YYr104	9
#define YYr110	10
#define YYr125	11
#define YYr130	12
#define YYr135	13
#define YYr139	14
#define YYr140	15
#define YYr141	16
#define YYr142	17
#define YYr148	18
#define YYr149	19
#define YYr150	20
#define YYr151	21
#define YYr152	22
#define YYr153	23
#define YYr154	24
#define YYr155	25
#define YYr156	26
#define YYr157	27
#define YYr158	28
#define YYr159	29
#define YYr168	30
#define YYr170	31
#define YYr173	32
#define YYr192	33
#define YYr193	34
#define YYr194	35
#define YYr195	36
#define YYr196	37
#define YYr197	38
#define YYr208	39
#define YYr211	40
#define YYr217	41
#define YYr225	42
#define YYr227	43
#define YYr237	44
#define YYr238	45
#define YYr244	46
#define YYr248	47
#define YYr249	48
#define YYr250	49
#define YYr251	50
#define YYr252	51
#define YYr253	52
#define YYr255	53
#define YYr265	54
#define YYr271	55
#define YYr274	56
#define YYr286	57
#define YYr287	58
#define YYr289	59
#define YYr291	60
#define YYr293	61
#define YYr295	62
#define YYr296	63
#define YYr300	64
#define YYr299	65
#define YYr298	66
#define YYr297	67
#define YYr294	68
#define YYr292	69
#define YYr290	70
#define YYr285	71
#define YYr284	72
#define YYr283	73
#define YYr282	74
#define YYr281	75
#define YYr280	76
#define YYr279	77
#define YYr278	78
#define YYr277	79
#define YYr276	80
#define YYr275	81
#define YYr273	82
#define YYr272	83
#define YYr268	84
#define YYr267	85
#define YYr266	86
#define YYr264	87
#define YYr263	88
#define YYr262	89
#define YYr260	90
#define YYr259	91
#define YYr258	92
#define YYr256	93
#define YYr254	94
#define YYr246	95
#define YYr245	96
#define YYr242	97
#define YYr241	98
#define YYr240	99
#define YYr239	100
#define YYr236	101
#define YYr235	102
#define YYr234	103
#define YYr232	104
#define YYr231	105
#define YYr230	106
#define YYr226	107
#define YYr224	108
#define YYr223	109
#define YYr222	110
#define YYr221	111
#define YYr220	112
#define YYr219	113
#define YYr218	114
#define YYr216	115
#define YYr215	116
#define YYr212	117
#define YYr210	118
#define YYr207	119
#define YYr206	120
#define YYr205	121
#define YYr204	122
#define YYr202	123
#define YYr201	124
#define YYr200	125
#define YYr199	126
#define YYr189	127
#define YYr187	128
#define YYr186	129
#define YYr185	130
#define YYr184	131
#define YYr182	132
#define YYr181	133
#define YYr180	134
#define YYr179	135
#define YYr178	136
#define YYr177	137
#define YYr175	138
#define YYr172	139
#define YYr171	140
#define YYr169	141
#define YYr167	142
#define YYr166	143
#define YYr165	144
#define YYr164	145
#define YYr163	146
#define YYr162	147
#define YYr161	148
#define YYr160	149
#define YYr144	150
#define YYr138	151
#define YYr137	152
#define YYr136	153
#define YYr132	154
#define YYr131	155
#define YYr126	156
#define YYr122	157
#define YYr121	158
#define YYr120	159
#define YYr119	160
#define YYr117	161
#define YYr116	162
#define YYr115	163
#define YYr112	164
#define YYr109	165
#define YYr108	166
#define YYr107	167
#define YYr106	168
#define YYr105	169
#define YYr100	170
#define YYr96	171
#define YYr94	172
#define YYr93	173
#define YYr90	174
#define YYr89	175
#define YYr88	176
#define YYr87	177
#define YYr86	178
#define YYr83	179
#define YYr82	180
#define YYr81	181
#define YYr78	182
#define YYr77	183
#define YYr76	184
#define YYr75	185
#define YYr74	186
#define YYr73	187
#define YYr72	188
#define YYr71	189
#define YYr70	190
#define YYr69	191
#define YYr68	192
#define YYr67	193
#define YYr65	194
#define YYr64	195
#define YYr63	196
#define YYr62	197
#define YYr61	198
#define YYr60	199
#define YYr59	200
#define YYr58	201
#define YYr57	202
#define YYr56	203
#define YYr55	204
#define YYr54	205
#define YYr53	206
#define YYr52	207
#define YYr51	208
#define YYr50	209
#define YYr49	210
#define YYr48	211
#define YYr47	212
#define YYr36	213
#define YYr35	214
#define YYr34	215
#define YYr33	216
#define YYr32	217
#define YYr31	218
#define YYr30	219
#define YYr20	220
#define YYr19	221
#define YYr18	222
#define YYr17	223
#define YYr16	224
#define YYr15	225
#define YYr14	226
#define YYr13	227
#define YYr12	228
#define YYr10	229
#define YYr9	230
#define YYr8	231
#define YYr7	232
#define YYr6	233
#define YYr5	234
#define YYr3	235
#define YYrACCEPT	YYr301
#define YYrERROR	YYr302
#define YYrLR2	YYr303
#line 2 "/etc/yyparse.c"

/*
*****************************************************************************
**									    *
**  Copyright  Digital Equipment Corporation, 1990, 1991, 1992, 1993	    *
**  All Rights Reserved.  Unpublished rights reserved under  the  copyright *
**  laws of the United States.						    *
**									    *
**  The software contained on this media is proprietary to and embodies the *
**  confidential  technology of Digital Equipment Corporation.  Possession, *
**  use,  duplication  or  dissemination  of  the  software  and  media  is *
**  authorized  only  pursuant  to  a  valid  written  license from Digital *
**  Equipment Corporation.						    *
**									    *
**  RESTRICTED RIGHTS LEGEND   Use, duplication, or disclosure by the  U.S. *
**  Government  is  subject  to  restrictions  as set forth in Subparagraph *
**  (c)(1)(ii) of DFARS 252.227-7013, or in FAR 52.227-19, as applicable.   *
**									    *
*****************************************************************************
*/

/*
 * Copyright 1985, 1990 by Mortice Kern Systems Inc.  All rights reserved.
 *
 * This Software is unpublished, valuable, confidential property of
 * Mortice Kern Systems Inc.  Use is authorized only in accordance
 * with the terms and conditions of the source licence agreement
 * protecting this Software.  Any unauthorized use or disclosure of
 * this Software is strictly prohibited and will result in the
 * termination of the licence agreement.
 *
 * If you have any questions, please consult your supervisor.
 * 
 * Automaton to interpret LALR(1) tables.
 *
 *	Macros:
 *		yyclearin - clear the lookahead token.
 *		yyerrok - forgive a pending error
 *		YYERROR - simulate an error
 *		YYACCEPT - halt and return 0
 *		YYABORT - halt and return 1
 *		YYRETURN(value) - halt and return value.  You should use this
 *			instead of return(value).
 *		YYREAD - ensure yychar contains a lookahead token by reading
 *			one if it does not.  See also YYSYNC.
 *		YYRECOVERING - 1 if syntax error detected and not recovered
 *			yet; otherwise, 0.
 *
 *	Preprocessor flags:
 *		YYDEBUG - includes debug code.  The parser will print
 *			 a travelogue of the parse if this is defined
 *			 and yydebug is non-zero.
 *		YYSSIZE - size of state and value stacks (default 150).
 *		YYSTATIC - By default, the state stack is an automatic array.
 *			If this is defined, the stack will be static.
 *			In either case, the value stack is static.
 *		YYALLOC - Dynamically allocate both the state and value stacks
 *			by calling malloc() and free().
 *		YYLR2 - defined if lookahead is needed to resolve R/R or S/R conflicts
 *		YYSYNC - if defined, yacc guarantees to fetch a lookahead token
 *			before any action, even if it doesnt need it for a decision.
 *			If YYSYNC is defined, YYREAD will never be necessary unless
 *			the user explicitly sets yychar = -1
 *
 *	Copyright (c) 1983, by the University of Waterloo
 */

/* GENTEXT: yyerror */
#ifndef I18N
#define	gettext(x)	x 
#else
#define	gettext(x)	x             /* <<< modified! */
#endif

#ifndef YYSSIZE
# define YYSSIZE	150
#endif
#ifndef	YYDEBUG
#define	YYDEBUG	0
#endif
#define YYERROR		goto yyerrlabel
#define yyerrok		yyerrflag = 0
#define yyclearin	yychar = -1
#define YYACCEPT	YYRETURN(0)
#define YYABORT		YYRETURN(1)
#define YYRECOVERING()	(yyerrflag != 0)
#ifdef YYALLOC
# define YYRETURN(val)	{ retval = (val); goto yyReturn; }
#else
# define YYRETURN(val)	return(val)
#endif
#if YYDEBUG
/* The if..else makes this macro behave exactly like a statement */
# define YYREAD	if (yychar < 0) {					\
			if ((yychar = yylex()) < 0)			\
				yychar = 0;				\
			if (yydebug)					\
				printf(gettext("read %s (%d)\n"), 	\
				yyptok(yychar),				\
				yychar);				\
		} else
#else
# define YYREAD	if (yychar < 0) {					\
			if ((yychar = yylex()) < 0)			\
				yychar = 0;				\
		} else
#endif
#define YYERRCODE	256		/* value of `error' */
#if 0 && defined(__TURBOC__) && __SMALL__
	/* THIS ONLY WORKS ON TURBO C 1.5 !!! */
#define	YYQYYP	*(int *)((int)yyq + ((int)yyq-(int)yyp))
#else
#define	YYQYYP	yyq[yyq-yyp]
#endif

YYSTYPE	yyval;				/* $$ */
YYSTYPE	*yypvt;				/* $n */
YYSTYPE	yylval;				/* yylex() sets this */

int	yychar,				/* current token */
	yyerrflag,			/* error flag */
	yynerrs;			/* error count */

#if YYDEBUG
int yydebug = 0;		/* debug flag & tables */
extern char	*yysvar[], *yystoken[], *yyptok();
extern short	yyrmap[], yysmap[];
extern int	yynstate, yynvar, yyntoken, yynrule;
# define yyassert(condition, msg, arg) \
	if (!(condition)) { printf(gettext("\nyacc bug: ")); printf(msg, arg); YYABORT; }
#else /* !YYDEBUG */
# define yyassert(condition, msg, arg)
#endif

yyparse()
{

	register short		yyi, *yyp;	/* for table lookup */
	register short		*yyps;		/* top of state stack */
	register short		yystate;	/* current state */
	register YYSTYPE	*yypv;		/* top of value stack */
	register short		*yyq;
	register int		yyj;

#ifdef YYSTATIC
	static short	yys[YYSSIZE + 1];
	static YYSTYPE	yyv[YYSSIZE + 1];
#else
#ifdef YYALLOC
	YYSTYPE *yyv;
	short	*yys;
	YYSTYPE save_yylval;
	YYSTYPE save_yyval;
	YYSTYPE *save_yypvt;
	int save_yychar, save_yyerrflag, save_yynerrs;
	int retval;
#if 0	/* defined in <stdlib.h>*/
	extern char	*malloc();
#endif
#else
	short		yys[YYSSIZE + 1];
	static YYSTYPE	yyv[YYSSIZE + 1];	/* historically static */
#endif
#endif

#ifdef YYALLOC
	yys = (short *) malloc((YYSSIZE + 1) * sizeof(short));
	yyv = (YYSTYPE *) malloc((YYSSIZE + 1) * sizeof(YYSTYPE));
	if (yys == (short *)0 || yyv == (YYSTYPE *)0) {
		yyerror("Not enough space for parser stacks");
		return 1;
	}
	save_yylval = yylval;
	save_yyval = yyval;
	save_yypvt = yypvt;
	save_yychar = yychar;
	save_yyerrflag = yyerrflag;
	save_yynerrs = yynerrs;
#endif

	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;
	yyps = yys;
	yypv = yyv;
	yystate = YYS0;		/* start state */

yyStack:
	yyassert((unsigned)yystate < yynstate, gettext("state %d\n"), yystate);
	if (++yyps > &yys[YYSSIZE]) {
		yyerror("Parser stack overflow");
		YYABORT;
	}
	*yyps = yystate;	/* stack current state */
	*++yypv = yyval;	/* ... and value */

#if YYDEBUG
	if (yydebug)
		printf(gettext("state %d (%d), char %s (%d)\n"),yysmap[yystate],
			yystate, yyptok(yychar), yychar);
#endif

	/*
	 *	Look up next action in action table.
	 */
yyEncore:
#ifdef YYSYNC
	YYREAD;
#endif
	if (yystate >= sizeof yypact/sizeof yypact[0]) 	/* simple state */
		yyi = yystate - YYDELTA;	/* reduce in any case */
	else {
		if(*(yyp = &yyact[yypact[yystate]]) >= 0) {
			/* Look for a shift on yychar */
#ifndef YYSYNC
			YYREAD;
#endif
			yyq = yyp;
			yyi = yychar;
#if 0 && defined(__TURBOC__) && __SMALL__
	/* THIS ONLY WORKS ON TURBO C 1.5 !!! */
			/* yyi is in di, yyp is in si */
		L01:
			asm lodsw	/* ax = *yyp++; */
			asm cmp yyi, ax
			asm jl L01
#else
			while (yyi < *yyp++)
				;
#endif
			if (yyi == yyp[-1]) {
				yystate = ~YYQYYP;
#if YYDEBUG
				if (yydebug)
					printf(gettext("shift %d (%d)\n"),
						yysmap[yystate], yystate);
#endif
				yyval = yylval;		/* stack what yylex() set */
				yychar = -1;		/* clear token */
				if (yyerrflag)
					yyerrflag--;	/* successful shift */
				goto yyStack;
			}
		}

		/*
	 	 *	Fell through - take default action
	 	 */

		if (yystate >= sizeof yydef /sizeof yydef[0])
			goto yyError;
		if ((yyi = yydef[yystate]) < 0)	 { /* default == reduce? */
											/* Search exception table */
			yyassert((unsigned)~yyi < sizeof yyex/sizeof yyex[0],
				gettext("exception %d\n"), yystate);
			yyp = &yyex[~yyi];
#ifndef YYSYNC
			YYREAD;
#endif
			while((yyi = *yyp) >= 0 && yyi != yychar)
				yyp += 2;
			yyi = yyp[1];
			yyassert(yyi >= 0,
				 gettext("Ex table not reduce %d\n"), yyi);
		}
	}

#ifdef YYLR2
yyReduce:	/* reduce yyi */
#endif
	yyassert((unsigned)yyi < yynrule, gettext("reduce %d\n"), yyi);
	yyj = yyrlen[yyi];
#if YYDEBUG
	if (yydebug) printf(gettext("reduce %d (%d), pops %d (%d)\n"), 
		yyrmap[yyi], yyi, yysmap[yyps[-yyj]], yyps[-yyj]);
#endif
	yyps -= yyj;		/* pop stacks */
	yypvt = yypv;		/* save top */
	yypv -= yyj;
	yyval = yypv[1];	/* default action $$ = $1 */
	switch (yyi) {		/* perform semantic action */
		
case YYr3: {	/* stat :  thislabel entry */
#line 226 "gram.in"



		  lastwasbranch = NO; 
} break;

case YYr5: {	/* stat :  thislabel exec */
#line 232 "gram.in"
 
		  if (parstate == INDATA && laststfcn != thisstno)
			parstate = INEXEC;
		  thisstno++;
		  if(yypvt[-1].labval && (yypvt[-1].labval->labelno==dorange))
			enddo(yypvt[-1].labval->labelno);
		  if(lastwasbranch && thislabel==NULL)
			warn("statement cannot be reached");
		  lastwasbranch = thiswasbranch;
		  thiswasbranch = NO;
		  if(yypvt[-1].labval)
			{
			if(yypvt[-1].labval->labtype == LABFORMAT)
				err("label already that of a format");
			else
				yypvt[-1].labval->labtype = LABEXEC;
			}
		  freetemps();
		
} break;

case YYr6: {	/* stat :  thislabel SINCLUDE filename */
#line 252 "gram.in"
 if (can_include)
			doinclude( yypvt[0].charpval );
		  else {
			fprintf(diagfile, "Cannot open file %s\n", yypvt[0].charpval);
			done(1);
			}
		
} break;

case YYr7: {	/* stat :  thislabel SEND end_spec */
#line 260 "gram.in"
 if (yypvt[-2].labval)
			lastwasbranch = NO;
		  endproc(); 
		
} break;

case YYr8: {	/* stat :  thislabel SUNKNOWN */
#line 265 "gram.in"
 extern void unclassifiable();
		  unclassifiable();



		  flline(); 
} break;

case YYr9: {	/* stat :  error */
#line 272 "gram.in"
 flline();  needkwd = NO;  inioctl = NO;
		  yyerrok; yyclearin; 
} break;

case YYr10: {	/* thislabel :  SLABEL */
#line 277 "gram.in"

		if(yystno != 0)
			{
			yyval.labval = thislabel =  mklabel(yystno);
			if( ! headerdone ) {
				if (procclass == CLUNKNOWN)
					procclass = CLMAIN;
				puthead(CNULL, procclass);
				}
			if(thislabel->labdefined)
				execerr("label %s already defined",
					convic(thislabel->stateno) );
			else	{
				if(thislabel->blklevel!=0 && thislabel->blklevel<blklevel
				    && thislabel->labtype!=LABFORMAT)
					warn1("there is a branch to label %s from outside block",
					      convic( (ftnint) (thislabel->stateno) ) );
				thislabel->blklevel = blklevel;
				thislabel->labdefined = YES;
				if(thislabel->labtype != LABFORMAT)
					p1_label((long)(thislabel - labeltab));
				}
			}
		else    yyval.labval = thislabel = NULL;
		
} break;

case YYr11: {	/* entry :  SPROGRAM new_proc progname */
#line 305 "gram.in"
startproc(yypvt[0].extval, CLMAIN); 
} break;

case YYr12: {	/* entry :  SPROGRAM new_proc progname progarglist */
#line 307 "gram.in"
	warn("ignoring arguments to main program");
			
			startproc(yypvt[-1].extval, CLMAIN); 
} break;

case YYr13: {	/* entry :  SBLOCK new_proc progname */
#line 311 "gram.in"
 if(yypvt[0].extval) NO66("named BLOCKDATA");
		  startproc(yypvt[0].extval, CLBLOCK); 
} break;

case YYr14: {	/* entry :  SSUBROUTINE new_proc entryname arglist */
#line 314 "gram.in"
 entrypt(CLPROC, TYSUBR, (ftnint) 0,  yypvt[-1].extval, yypvt[0].chval); 
} break;

case YYr15: {	/* entry :  SFUNCTION new_proc entryname arglist */
#line 316 "gram.in"
 entrypt(CLPROC, TYUNKNOWN, (ftnint) 0, yypvt[-1].extval, yypvt[0].chval); 
} break;

case YYr16: {	/* entry :  type SFUNCTION new_proc entryname arglist */
#line 318 "gram.in"
 entrypt(CLPROC, yypvt[-4].ival, varleng, yypvt[-1].extval, yypvt[0].chval); 
} break;

case YYr17: {	/* entry :  SENTRY entryname arglist */
#line 320 "gram.in"
 if(parstate==OUTSIDE || procclass==CLMAIN
			|| procclass==CLBLOCK)
				execerr("misplaced entry statement", CNULL);
		  entrypt(CLENTRY, 0, (ftnint) 0, yypvt[-1].extval, yypvt[0].chval);
		
} break;

case YYr18: {	/* new_proc :  */
#line 328 "gram.in"
 newproc(); 
} break;

case YYr19: {	/* entryname :  name */
#line 332 "gram.in"
 yyval.extval = newentry(yypvt[0].namval, 1); 
} break;

case YYr20: {	/* name :  SNAME */
#line 336 "gram.in"
 yyval.namval = mkname(token); 
} break;

case YYr21: {	/* progname :  */
#line 339 "gram.in"
 yyval.extval = NULL; 
} break;

case YYr29: {	/* arglist :  */
#line 357 "gram.in"
 yyval.chval = 0; 
} break;

case YYr30: {	/* arglist :  SLPAR SRPAR */
#line 359 "gram.in"
 NO66(" () argument list");
		  yyval.chval = 0; 
} break;

case YYr31: {	/* arglist :  SLPAR args SRPAR */
#line 362 "gram.in"
yyval.chval = yypvt[-1].chval; 
} break;

case YYr32: {	/* args :  arg */
#line 366 "gram.in"
 yyval.chval = (yypvt[0].namval ? mkchain((char *)yypvt[0].namval,CHNULL) : CHNULL ); 
} break;

case YYr33: {	/* args :  args SCOMMA arg */
#line 368 "gram.in"
 if(yypvt[0].namval) yypvt[-2].chval = yyval.chval = mkchain((char *)yypvt[0].namval, yypvt[-2].chval); 
} break;

case YYr34: {	/* arg :  name */
#line 372 "gram.in"
 if(yypvt[0].namval->vstg!=STGUNKNOWN && yypvt[0].namval->vstg!=STGARG)
			dclerr("name declared as argument after use", yypvt[0].namval);
		  yypvt[0].namval->vstg = STGARG;
		
} break;

case YYr35: {	/* arg :  SSTAR */
#line 377 "gram.in"
 NO66("altenate return argument");



		  yyval.namval = 0;  substars = YES; 
} break;

case YYr36: {	/* filename :  SHOLLERITH */
#line 393 "gram.in"

		char *s;
		s = copyn(toklen+1, token);
		s[toklen] = '\0';
		yyval.charpval = s;
		
} break;

case YYr45: {	/* spec :  SSAVE */
#line 409 "gram.in"
 NO66("SAVE statement");
		  saveall = YES; 
} break;

case YYr46: {	/* spec :  SSAVE savelist */
#line 412 "gram.in"
 NO66("SAVE statement"); 
} break;

case YYr47: {	/* spec :  SFORMAT */
#line 414 "gram.in"
 fmtstmt(thislabel); setfmt(thislabel); 
} break;

case YYr48: {	/* spec :  SPARAM in_dcl SLPAR paramlist SRPAR */
#line 416 "gram.in"
 NO66("PARAMETER statement"); 
} break;

case YYr49: {	/* dcl :  type opt_comma name in_dcl new_dcl dims lengspec */
#line 420 "gram.in"
 settype(yypvt[-4].namval, yypvt[-6].ival, yypvt[0].lval);
		  if(ndim>0) setbound(yypvt[-4].namval,ndim,dims);
		
} break;

case YYr50: {	/* dcl :  dcl SCOMMA name dims lengspec */
#line 424 "gram.in"
 settype(yypvt[-2].namval, yypvt[-4].ival, yypvt[0].lval);
		  if(ndim>0) setbound(yypvt[-2].namval,ndim,dims);
		
} break;

case YYr51: {	/* dcl :  dcl SSLASHD datainit vallist SSLASHD */
#line 428 "gram.in"
 if (new_dcl == 2) {
			err("attempt to give DATA in type-declaration");
			new_dcl = 1;
			}
		
} break;

case YYr52: {	/* new_dcl :  */
#line 435 "gram.in"
 new_dcl = 2; 
} break;

case YYr53: {	/* type :  typespec lengspec */
#line 439 "gram.in"
 varleng = yypvt[0].lval; 
} break;

case YYr54: {	/* typespec :  typename */
#line 443 "gram.in"
 varleng = (yypvt[0].ival<0 || ONEOF(yypvt[0].ival,M(TYLOGICAL)|M(TYLONG))
				? 0 : typesize[yypvt[0].ival]);
		  vartype = yypvt[0].ival; 
} break;

case YYr55: {	/* typename :  SINTEGER */
#line 448 "gram.in"
 yyval.ival = TYLONG; 
} break;

case YYr56: {	/* typename :  SREAL */
#line 449 "gram.in"
 yyval.ival = tyreal; 
} break;

case YYr57: {	/* typename :  SCOMPLEX */
#line 450 "gram.in"
 ++complex_seen; yyval.ival = tycomplex; 
} break;

case YYr58: {	/* typename :  SDOUBLE */
#line 451 "gram.in"
 yyval.ival = TYDREAL; 
} break;

case YYr59: {	/* typename :  SDCOMPLEX */
#line 452 "gram.in"
 ++dcomplex_seen; NOEXT("DOUBLE COMPLEX statement"); yyval.ival = TYDCOMPLEX; 
} break;

case YYr60: {	/* typename :  SLOGICAL */
#line 453 "gram.in"
 yyval.ival = TYLOGICAL; 
} break;

case YYr61: {	/* typename :  SCHARACTER */
#line 454 "gram.in"
 NO66("CHARACTER statement"); yyval.ival = TYCHAR; 
} break;

case YYr62: {	/* typename :  SUNDEFINED */
#line 455 "gram.in"
 yyval.ival = TYUNKNOWN; 
} break;

case YYr63: {	/* typename :  SDIMENSION */
#line 456 "gram.in"
 yyval.ival = TYUNKNOWN; 
} break;

case YYr64: {	/* typename :  SAUTOMATIC */
#line 457 "gram.in"
 NOEXT("AUTOMATIC statement"); yyval.ival = - STGAUTO; 
} break;

case YYr65: {	/* typename :  SSTATIC */
#line 458 "gram.in"
 NOEXT("STATIC statement"); yyval.ival = - STGBSS; 
} break;

case YYr66: {	/* lengspec :  */
#line 462 "gram.in"
 yyval.lval = varleng; 
} break;

case YYr67: {	/* lengspec :  SSTAR intonlyon expr intonlyoff */
#line 464 "gram.in"

		expptr p;
		p = yypvt[-1].expval;
		NO66("length specification *n");
		if( ! ISICON(p) || p->constblock.Const.ci <= 0 )
			{
			yyval.lval = 0;
			dclerr("length must be a positive integer constant",
				NPNULL);
			}
		else {
			if (vartype == TYCHAR)
				yyval.lval = p->constblock.Const.ci;
			else switch((int)p->constblock.Const.ci) {
				case 1:	yyval.lval = 1; break;
				case 2: yyval.lval = typesize[TYSHORT];	break;
				case 4: yyval.lval = typesize[TYLONG];	break;
				case 8: yyval.lval = typesize[TYDREAL];	break;
				case 16: yyval.lval = typesize[TYDCOMPLEX]; break;
				default:
					dclerr("invalid length",NPNULL);
					yyval.lval = varleng;
				}
			}
		
} break;

case YYr68: {	/* lengspec :  SSTAR intonlyon SLPAR SSTAR SRPAR intonlyoff */
#line 490 "gram.in"
 NO66("length specification *(*)"); yyval.lval = -1; 
} break;

case YYr69: {	/* common :  SCOMMON in_dcl var */
#line 494 "gram.in"
 incomm( yyval.extval = comblock("") , yypvt[0].namval ); 
} break;

case YYr70: {	/* common :  SCOMMON in_dcl comblock var */
#line 496 "gram.in"
 yyval.extval = yypvt[-1].extval;  incomm(yypvt[-1].extval, yypvt[0].namval); 
} break;

case YYr71: {	/* common :  common opt_comma comblock opt_comma var */
#line 498 "gram.in"
 yyval.extval = yypvt[-2].extval;  incomm(yypvt[-2].extval, yypvt[0].namval); 
} break;

case YYr72: {	/* common :  common SCOMMA var */
#line 500 "gram.in"
 incomm(yypvt[-2].extval, yypvt[0].namval); 
} break;

case YYr73: {	/* comblock :  SCONCAT */
#line 504 "gram.in"
 yyval.extval = comblock(""); 
} break;

case YYr74: {	/* comblock :  SSLASH SNAME SSLASH */
#line 506 "gram.in"
 yyval.extval = comblock(token); 
} break;

case YYr75: {	/* external :  SEXTERNAL in_dcl name */
#line 510 "gram.in"
 setext(yypvt[0].namval); 
} break;

case YYr76: {	/* external :  external SCOMMA name */
#line 512 "gram.in"
 setext(yypvt[0].namval); 
} break;

case YYr77: {	/* intrinsic :  SINTRINSIC in_dcl name */
#line 516 "gram.in"
 NO66("INTRINSIC statement"); setintr(yypvt[0].namval); 
} break;

case YYr78: {	/* intrinsic :  intrinsic SCOMMA name */
#line 518 "gram.in"
 setintr(yypvt[0].namval); 
} break;

case YYr81: {	/* equivset :  SLPAR equivlist SRPAR */
#line 526 "gram.in"

		struct Equivblock *p;
		if(nequiv >= maxequiv)
			many("equivalences", 'q', maxequiv);
		p  =  & eqvclass[nequiv++];
		p->eqvinit = NO;
		p->eqvbottom = 0;
		p->eqvtop = 0;
		p->equivs = yypvt[-1].eqvval;
		
} break;

case YYr82: {	/* equivlist :  lhs */
#line 539 "gram.in"
 yyval.eqvval=ALLOC(Eqvchain);
		  yyval.eqvval->eqvitem.eqvlhs = (struct Primblock *)yypvt[0].expval;
		
} break;

case YYr83: {	/* equivlist :  equivlist SCOMMA lhs */
#line 543 "gram.in"
 yyval.eqvval=ALLOC(Eqvchain);
		  yyval.eqvval->eqvitem.eqvlhs = (struct Primblock *) yypvt[0].expval;
		  yyval.eqvval->eqvnextp = yypvt[-2].eqvval;
		
} break;

case YYr86: {	/* in_data :  */
#line 554 "gram.in"
 if(parstate == OUTSIDE)
			{
			newproc();
			startproc(ESNULL, CLMAIN);
			}
		  if(parstate < INDATA)
			{
			enddcl();
			parstate = INDATA;
			datagripe = 1;
			}
		
} break;

case YYr87: {	/* datalist :  datainit datavarlist SSLASH datapop vallist SSLASH */
#line 569 "gram.in"
 ftnint junk;
		  if(nextdata(&junk) != NULL)
			err("too few initializers");
		  frdata(yypvt[-4].chval);
		  frrpl();
		
} break;

case YYr88: {	/* datainit :  */
#line 577 "gram.in"
 frchain(&datastack); curdtp = 0; 
} break;

case YYr89: {	/* datapop :  */
#line 580 "gram.in"
 pop_datastack(); 
} break;

case YYr90: {	/* vallist :  */
#line 583 "gram.in"
 toomanyinit = NO; 
} break;

case YYr93: {	/* val :  value */
#line 588 "gram.in"
 dataval(ENULL, yypvt[0].expval); 
} break;

case YYr94: {	/* val :  simple SSTAR value */
#line 590 "gram.in"
 dataval(yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr96: {	/* value :  addop simple */
#line 595 "gram.in"
 if( yypvt[-1].ival==OPMINUS && ISCONST(yypvt[0].expval) )
			consnegop((Constp)yypvt[0].expval);
		  yyval.expval = yypvt[0].expval;
		
} break;

case YYr100: {	/* saveitem :  name */
#line 607 "gram.in"
 int k;
		  yypvt[0].namval->vsave = YES;
		  k = yypvt[0].namval->vstg;
		if( ! ONEOF(k, M(STGUNKNOWN)|M(STGBSS)|M(STGINIT)) )
			dclerr("can only save static variables", yypvt[0].namval);
		
} break;

case YYr104: {	/* paramitem :  name SEQUALS expr */
#line 621 "gram.in"
 if(yypvt[-2].namval->vclass == CLUNKNOWN)
			make_param((struct Paramblock *)yypvt[-2].namval, yypvt[0].expval);
		  else dclerr("cannot make into parameter", yypvt[-2].namval);
		
} break;

case YYr105: {	/* var :  name dims */
#line 628 "gram.in"
 if(ndim>0) setbound(yypvt[-1].namval, ndim, dims); 
} break;

case YYr106: {	/* datavar :  lhs */
#line 632 "gram.in"
 Namep np;
		  np = ( (struct Primblock *) yypvt[0].expval) -> namep;
		  vardcl(np);
		  if(np->vstg == STGCOMMON)
			extsymtab[np->vardesc.varno].extinit = YES;
		  else if(np->vstg==STGEQUIV)
			eqvclass[np->vardesc.varno].eqvinit = YES;
		  else if(np->vstg!=STGINIT && np->vstg!=STGBSS)
			dclerr("inconsistent storage classes", np);
		  yyval.chval = mkchain((char *)yypvt[0].expval, CHNULL);
		
} break;

case YYr107: {	/* datavar :  SLPAR datavarlist SCOMMA dospec SRPAR */
#line 644 "gram.in"
 chainp p; struct Impldoblock *q;
		pop_datastack();
		q = ALLOC(Impldoblock);
		q->tag = TIMPLDO;
		(q->varnp = (Namep) (yypvt[-1].chval->datap))->vimpldovar = 1;
		p = yypvt[-1].chval->nextp;
		if(p)  { q->implb = (expptr)(p->datap); p = p->nextp; }
		if(p)  { q->impub = (expptr)(p->datap); p = p->nextp; }
		if(p)  { q->impstep = (expptr)(p->datap); }
		frchain( & (yypvt[-1].chval) );
		yyval.chval = mkchain((char *)q, CHNULL);
		q->datalist = hookup(yypvt[-3].chval, yyval.chval);
		
} break;

case YYr108: {	/* datavarlist :  datavar */
#line 660 "gram.in"
 if (!datastack)
			curdtp = 0;
		  datastack = mkchain((char *)curdtp, datastack);
		  curdtp = yypvt[0].chval; curdtelt = 0;
		  
} break;

case YYr109: {	/* datavarlist :  datavarlist SCOMMA datavar */
#line 666 "gram.in"
 yyval.chval = hookup(yypvt[-2].chval, yypvt[0].chval); 
} break;

case YYr110: {	/* dims :  */
#line 670 "gram.in"
 ndim = 0; 
} break;

case YYr112: {	/* dimlist :  */
#line 674 "gram.in"
 ndim = 0; 
} break;

case YYr115: {	/* dim :  ubound */
#line 679 "gram.in"

		  if(ndim == maxdim)
			err("too many dimensions");
		  else if(ndim < maxdim)
			{ dims[ndim].lb = 0;
			  dims[ndim].ub = yypvt[0].expval;
			}
		  ++ndim;
		
} break;

case YYr116: {	/* dim :  expr SCOLON ubound */
#line 689 "gram.in"

		  if(ndim == maxdim)
			err("too many dimensions");
		  else if(ndim < maxdim)
			{ dims[ndim].lb = yypvt[-2].expval;
			  dims[ndim].ub = yypvt[0].expval;
			}
		  ++ndim;
		
} break;

case YYr117: {	/* ubound :  SSTAR */
#line 701 "gram.in"
 yyval.expval = 0; 
} break;

case YYr119: {	/* labellist :  label */
#line 706 "gram.in"
 nstars = 1; labarray[0] = yypvt[0].labval; 
} break;

case YYr120: {	/* labellist :  labellist SCOMMA label */
#line 708 "gram.in"
 if(nstars < maxlablist)  labarray[nstars++] = yypvt[0].labval; 
} break;

case YYr121: {	/* label :  SICON */
#line 712 "gram.in"
 yyval.labval = execlab( convci(toklen, token) ); 
} break;

case YYr122: {	/* implicit :  SIMPLICIT in_dcl implist */
#line 716 "gram.in"
 NO66("IMPLICIT statement"); 
} break;

case YYr125: {	/* implist :  imptype */
#line 722 "gram.in"
 if (vartype != TYUNKNOWN)
			dclerr("-- expected letter range",NPNULL);
		  setimpl(vartype, varleng, 'a', 'z'); 
} break;

case YYr126: {	/* imptype :  */
#line 727 "gram.in"
 needkwd = 1; 
} break;

case YYr130: {	/* letgroup :  letter */
#line 736 "gram.in"
 setimpl(vartype, varleng, yypvt[0].ival, yypvt[0].ival); 
} break;

case YYr131: {	/* letgroup :  letter SMINUS letter */
#line 738 "gram.in"
 setimpl(vartype, varleng, yypvt[-2].ival, yypvt[0].ival); 
} break;

case YYr132: {	/* letter :  SNAME */
#line 742 "gram.in"
 if(toklen!=1 || token[0]<'a' || token[0]>'z')
			{
			dclerr("implicit item must be single letter", NPNULL);
			yyval.ival = 0;
			}
		  else yyval.ival = token[0];
		
} break;

case YYr135: {	/* namelistentry :  SSLASH name SSLASH namelistlist */
#line 756 "gram.in"

		if(yypvt[-2].namval->vclass == CLUNKNOWN)
			{
			yypvt[-2].namval->vclass = CLNAMELIST;
			yypvt[-2].namval->vtype = TYINT;
			yypvt[-2].namval->vstg = STGBSS;
			yypvt[-2].namval->varxptr.namelist = yypvt[0].chval;
			yypvt[-2].namval->vardesc.varno = ++lastvarno;
			}
		else dclerr("cannot be a namelist name", yypvt[-2].namval);
		
} break;

case YYr136: {	/* namelistlist :  name */
#line 770 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].namval, CHNULL); 
} break;

case YYr137: {	/* namelistlist :  namelistlist SCOMMA name */
#line 772 "gram.in"
 yyval.chval = hookup(yypvt[-2].chval, mkchain((char *)yypvt[0].namval, CHNULL)); 
} break;

case YYr138: {	/* in_dcl :  */
#line 776 "gram.in"
 switch(parstate)
			{
			case OUTSIDE:	newproc();
					startproc(ESNULL, CLMAIN);
			case INSIDE:	parstate = INDCL;
			case INDCL:	break;

			case INDATA:
				if (datagripe) {
					errstr(
				"Statement order error: declaration after DATA",
						CNULL);
					datagripe = 0;
					}
				break;

			default:
				dclerr("declaration among executables", NPNULL);
			}
		
} break;

case YYr139: {	/* funarglist :  */
#line 798 "gram.in"
 yyval.chval = 0; 
} break;

case YYr140: {	/* funarglist :  funargs */
#line 800 "gram.in"
 yyval.chval = revchain(yypvt[0].chval); 
} break;

case YYr141: {	/* funargs :  expr */
#line 804 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].expval, CHNULL); 
} break;

case YYr142: {	/* funargs :  funargs SCOMMA expr */
#line 806 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].expval, yypvt[-2].chval); 
} break;

case YYr144: {	/* expr :  SLPAR expr SRPAR */
#line 811 "gram.in"
 yyval.expval = yypvt[-1].expval; if (yyval.expval->tag == TPRIM)
					yyval.expval->primblock.parenused = 1; 
} break;

case YYr148: {	/* uexpr :  expr addop expr */
#line 819 "gram.in"
 yyval.expval = mkexpr(yypvt[-1].ival, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr149: {	/* uexpr :  expr SSTAR expr */
#line 821 "gram.in"
 yyval.expval = mkexpr(OPSTAR, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr150: {	/* uexpr :  expr SSLASH expr */
#line 823 "gram.in"
 yyval.expval = mkexpr(OPSLASH, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr151: {	/* uexpr :  expr SPOWER expr */
#line 825 "gram.in"
 yyval.expval = mkexpr(OPPOWER, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr152: {	/* uexpr :  addop expr */
#line 827 "gram.in"
 if(yypvt[-1].ival == OPMINUS)
			yyval.expval = mkexpr(OPNEG, yypvt[0].expval, ENULL);
		  else 	yyval.expval = yypvt[0].expval;
		
} break;

case YYr153: {	/* uexpr :  expr relop expr */
#line 832 "gram.in"
 yyval.expval = mkexpr(yypvt[-1].ival, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr154: {	/* uexpr :  expr SEQV expr */
#line 834 "gram.in"
 NO66(".EQV. operator");
		  yyval.expval = mkexpr(OPEQV, yypvt[-2].expval,yypvt[0].expval); 
} break;

case YYr155: {	/* uexpr :  expr SNEQV expr */
#line 837 "gram.in"
 NO66(".NEQV. operator");
		  yyval.expval = mkexpr(OPNEQV, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr156: {	/* uexpr :  expr SOR expr */
#line 840 "gram.in"
 yyval.expval = mkexpr(OPOR, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr157: {	/* uexpr :  expr SAND expr */
#line 842 "gram.in"
 yyval.expval = mkexpr(OPAND, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr158: {	/* uexpr :  SNOT expr */
#line 844 "gram.in"
 yyval.expval = mkexpr(OPNOT, yypvt[0].expval, ENULL); 
} break;

case YYr159: {	/* uexpr :  expr SCONCAT expr */
#line 846 "gram.in"
 NO66("concatenation operator //");
		  yyval.expval = mkexpr(OPCONCAT, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr160: {	/* addop :  SPLUS */
#line 850 "gram.in"
 yyval.ival = OPPLUS; 
} break;

case YYr161: {	/* addop :  SMINUS */
#line 851 "gram.in"
 yyval.ival = OPMINUS; 
} break;

case YYr162: {	/* relop :  SEQ */
#line 854 "gram.in"
 yyval.ival = OPEQ; 
} break;

case YYr163: {	/* relop :  SGT */
#line 855 "gram.in"
 yyval.ival = OPGT; 
} break;

case YYr164: {	/* relop :  SLT */
#line 856 "gram.in"
 yyval.ival = OPLT; 
} break;

case YYr165: {	/* relop :  SGE */
#line 857 "gram.in"
 yyval.ival = OPGE; 
} break;

case YYr166: {	/* relop :  SLE */
#line 858 "gram.in"
 yyval.ival = OPLE; 
} break;

case YYr167: {	/* relop :  SNE */
#line 859 "gram.in"
 yyval.ival = OPNE; 
} break;

case YYr168: {	/* lhs :  name */
#line 863 "gram.in"
 yyval.expval = mkprim(yypvt[0].namval, LBNULL, CHNULL); 
} break;

case YYr169: {	/* lhs :  name substring */
#line 865 "gram.in"
 NO66("substring operator :");
		  yyval.expval = mkprim(yypvt[-1].namval, LBNULL, yypvt[0].chval); 
} break;

case YYr170: {	/* lhs :  name SLPAR funarglist SRPAR */
#line 868 "gram.in"
 yyval.expval = mkprim(yypvt[-3].namval, mklist(yypvt[-1].chval), CHNULL); 
} break;

case YYr171: {	/* lhs :  name SLPAR funarglist SRPAR substring */
#line 870 "gram.in"
 NO66("substring operator :");
		  yyval.expval = mkprim(yypvt[-4].namval, mklist(yypvt[-2].chval), yypvt[0].chval); 
} break;

case YYr172: {	/* substring :  SLPAR opt_expr SCOLON opt_expr SRPAR */
#line 875 "gram.in"
 yyval.chval = mkchain((char *)yypvt[-3].expval, mkchain((char *)yypvt[-1].expval,CHNULL)); 
} break;

case YYr173: {	/* opt_expr :  */
#line 879 "gram.in"
 yyval.expval = 0; 
} break;

case YYr175: {	/* simple :  name */
#line 884 "gram.in"
 if(yypvt[0].namval->vclass == CLPARAM)
			yyval.expval = (expptr) cpexpr(
				( (struct Paramblock *) (yypvt[0].namval) ) -> paramval);
		
} break;

case YYr177: {	/* simple_const :  STRUE */
#line 891 "gram.in"
 yyval.expval = mklogcon(1); 
} break;

case YYr178: {	/* simple_const :  SFALSE */
#line 892 "gram.in"
 yyval.expval = mklogcon(0); 
} break;

case YYr179: {	/* simple_const :  SHOLLERITH */
#line 893 "gram.in"
 yyval.expval = mkstrcon(toklen, token); 
} break;

case YYr180: {	/* simple_const :  SICON */
#line 894 "gram.in"
 yyval.expval = mkintcon( convci(toklen, token) ); 
} break;

case YYr181: {	/* simple_const :  SRCON */
#line 895 "gram.in"
 yyval.expval = mkrealcon(tyreal, token); 
} break;

case YYr182: {	/* simple_const :  SDCON */
#line 896 "gram.in"
 yyval.expval = mkrealcon(TYDREAL, token); 
} break;

case YYr184: {	/* complex_const :  SLPAR uexpr SCOMMA uexpr SRPAR */
#line 901 "gram.in"
 yyval.expval = mkcxcon(yypvt[-3].expval,yypvt[-1].expval); 
} break;

case YYr185: {	/* bit_const :  SHEXCON */
#line 905 "gram.in"
 NOEXT("hex constant");
		  yyval.expval = mkbitcon(4, toklen, token); 
} break;

case YYr186: {	/* bit_const :  SOCTCON */
#line 908 "gram.in"
 NOEXT("octal constant");
		  yyval.expval = mkbitcon(3, toklen, token); 
} break;

case YYr187: {	/* bit_const :  SBITCON */
#line 911 "gram.in"
 NOEXT("binary constant");
		  yyval.expval = mkbitcon(1, toklen, token); 
} break;

case YYr189: {	/* fexpr :  SLPAR fexpr SRPAR */
#line 917 "gram.in"
 yyval.expval = yypvt[-1].expval; 
} break;

case YYr192: {	/* unpar_fexpr :  fexpr addop fexpr */
#line 923 "gram.in"
 yyval.expval = mkexpr(yypvt[-1].ival, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr193: {	/* unpar_fexpr :  fexpr SSTAR fexpr */
#line 925 "gram.in"
 yyval.expval = mkexpr(OPSTAR, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr194: {	/* unpar_fexpr :  fexpr SSLASH fexpr */
#line 927 "gram.in"
 yyval.expval = mkexpr(OPSLASH, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr195: {	/* unpar_fexpr :  fexpr SPOWER fexpr */
#line 929 "gram.in"
 yyval.expval = mkexpr(OPPOWER, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr196: {	/* unpar_fexpr :  addop fexpr */
#line 931 "gram.in"
 if(yypvt[-1].ival == OPMINUS)
			yyval.expval = mkexpr(OPNEG, yypvt[0].expval, ENULL);
		  else	yyval.expval = yypvt[0].expval;
		
} break;

case YYr197: {	/* unpar_fexpr :  fexpr SCONCAT fexpr */
#line 936 "gram.in"
 NO66("concatenation operator //");
		  yyval.expval = mkexpr(OPCONCAT, yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr199: {	/* exec :  SDO end_spec intonlyon label intonlyoff opt_comma dospecw */
#line 941 "gram.in"

		if(yypvt[-3].labval->labdefined)
			execerr("no backward DO loops", CNULL);
		yypvt[-3].labval->blklevel = blklevel+1;
		exdo(yypvt[-3].labval->labelno, NPNULL, yypvt[0].chval);
		
} break;

case YYr200: {	/* exec :  SDO end_spec opt_comma dospecw */
#line 948 "gram.in"

		exdo((int)(ctls - ctlstack - 2), NPNULL, yypvt[0].chval);
		NOEXT("DO without label");
		
} break;

case YYr201: {	/* exec :  SENDDO */
#line 953 "gram.in"
 exenddo(NPNULL); 
} break;

case YYr202: {	/* exec :  logif iffable */
#line 955 "gram.in"
 exendif();  thiswasbranch = NO; 
} break;

case YYr204: {	/* exec :  SELSEIF end_spec SLPAR expr SRPAR STHEN */
#line 958 "gram.in"
 exelif(yypvt[-2].expval); lastwasbranch = NO; 
} break;

case YYr205: {	/* exec :  SELSE end_spec */
#line 960 "gram.in"
 exelse(); lastwasbranch = NO; 
} break;

case YYr206: {	/* exec :  SENDIF end_spec */
#line 962 "gram.in"
 exendif(); lastwasbranch = NO; 
} break;

case YYr207: {	/* logif :  SLOGIF end_spec SLPAR expr SRPAR */
#line 966 "gram.in"
 exif(yypvt[-1].expval); 
} break;

case YYr208: {	/* dospec :  name SEQUALS exprlist */
#line 970 "gram.in"
 yyval.chval = mkchain((char *)yypvt[-2].namval, yypvt[0].chval); 
} break;

case YYr210: {	/* dospecw :  SWHILE SLPAR expr SRPAR */
#line 975 "gram.in"
 yyval.chval = mkchain(CNULL, (chainp)yypvt[-1].expval); 
} break;

case YYr211: {	/* iffable :  let lhs SEQUALS expr */
#line 979 "gram.in"
 exequals((struct Primblock *)yypvt[-2].expval, yypvt[0].expval); 
} break;

case YYr212: {	/* iffable :  SASSIGN end_spec assignlabel STO name */
#line 981 "gram.in"
 exassign(yypvt[0].namval, yypvt[-2].labval); 
} break;

case YYr215: {	/* iffable :  io */
#line 985 "gram.in"
 inioctl = NO; 
} break;

case YYr216: {	/* iffable :  SARITHIF end_spec SLPAR expr SRPAR label SCOMMA label SCOMMA label */
#line 987 "gram.in"
 exarif(yypvt[-6].expval, yypvt[-4].labval, yypvt[-2].labval, yypvt[0].labval);  thiswasbranch = YES; 
} break;

case YYr217: {	/* iffable :  call */
#line 989 "gram.in"
 excall(yypvt[0].namval, LBNULL, 0, labarray); 
} break;

case YYr218: {	/* iffable :  call SLPAR SRPAR */
#line 991 "gram.in"
 excall(yypvt[-2].namval, LBNULL, 0, labarray); 
} break;

case YYr219: {	/* iffable :  call SLPAR callarglist SRPAR */
#line 993 "gram.in"
 if(nstars < maxlablist)
			excall(yypvt[-3].namval, mklist(revchain(yypvt[-1].chval)), nstars, labarray);
		  else
			many("alternate returns", 'l', maxlablist);
		
} break;

case YYr220: {	/* iffable :  SRETURN end_spec opt_expr */
#line 999 "gram.in"
 exreturn(yypvt[0].expval);  thiswasbranch = YES; 
} break;

case YYr221: {	/* iffable :  stop end_spec opt_expr */
#line 1001 "gram.in"
 exstop(yypvt[-2].ival, yypvt[0].expval);  thiswasbranch = yypvt[-2].ival; 
} break;

case YYr222: {	/* assignlabel :  SICON */
#line 1005 "gram.in"
 yyval.labval = mklabel( convci(toklen, token) ); 
} break;

case YYr223: {	/* let :  SLET */
#line 1009 "gram.in"
 if(parstate == OUTSIDE)
			{
			newproc();
			startproc(ESNULL, CLMAIN);
			}
		
} break;

case YYr224: {	/* goto :  SGOTO end_spec label */
#line 1018 "gram.in"
 exgoto(yypvt[0].labval);  thiswasbranch = YES; 
} break;

case YYr225: {	/* goto :  SASGOTO end_spec name */
#line 1020 "gram.in"
 exasgoto(yypvt[0].namval);  thiswasbranch = YES; 
} break;

case YYr226: {	/* goto :  SASGOTO end_spec name opt_comma SLPAR labellist SRPAR */
#line 1022 "gram.in"
 exasgoto(yypvt[-4].namval);  thiswasbranch = YES; 
} break;

case YYr227: {	/* goto :  SCOMPGOTO end_spec SLPAR labellist SRPAR opt_comma expr */
#line 1024 "gram.in"
 if(nstars < maxlablist)
			putcmgo(putx(fixtype(yypvt[0].expval)), nstars, labarray);
		  else
			many("labels in computed GOTO list", 'l', maxlablist);
		
} break;

case YYr230: {	/* call :  SCALL end_spec name */
#line 1036 "gram.in"
 nstars = 0; yyval.namval = yypvt[0].namval; 
} break;

case YYr231: {	/* callarglist :  callarg */
#line 1040 "gram.in"
 yyval.chval = yypvt[0].expval ? mkchain((char *)yypvt[0].expval,CHNULL) : CHNULL; 
} break;

case YYr232: {	/* callarglist :  callarglist SCOMMA callarg */
#line 1042 "gram.in"
 yyval.chval = yypvt[0].expval ? mkchain((char *)yypvt[0].expval, yypvt[-2].chval) : yypvt[-2].chval; 
} break;

case YYr234: {	/* callarg :  SSTAR label */
#line 1047 "gram.in"
 if(nstars < maxlablist) labarray[nstars++] = yypvt[0].labval; yyval.expval = 0; 
} break;

case YYr235: {	/* stop :  SPAUSE */
#line 1051 "gram.in"
 yyval.ival = 0; 
} break;

case YYr236: {	/* stop :  SSTOP */
#line 1053 "gram.in"
 yyval.ival = 2; 
} break;

case YYr237: {	/* exprlist :  expr */
#line 1057 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].expval, CHNULL); 
} break;

case YYr238: {	/* exprlist :  exprlist SCOMMA expr */
#line 1059 "gram.in"
 yyval.chval = hookup(yypvt[-2].chval, mkchain((char *)yypvt[0].expval,CHNULL) ); 
} break;

case YYr239: {	/* end_spec :  */
#line 1063 "gram.in"
 if(parstate == OUTSIDE)
			{
			newproc();
			startproc(ESNULL, CLMAIN);
			}



		  if(parstate < INDATA) enddcl();
		
} break;

case YYr240: {	/* intonlyon :  */
#line 1076 "gram.in"
 intonly = YES; 
} break;

case YYr241: {	/* intonlyoff :  */
#line 1080 "gram.in"
 intonly = NO; 
} break;

case YYr242: {	/* io :  io1 */
#line 1085 "gram.in"
 endio(); 
} break;

case YYr244: {	/* io1 :  iofmove unpar_fexpr */
#line 1090 "gram.in"
 ioclause(IOSUNIT, yypvt[0].expval); endioctl(); 
} break;

case YYr245: {	/* io1 :  iofmove SSTAR */
#line 1092 "gram.in"
 ioclause(IOSUNIT, ENULL); endioctl(); 
} break;

case YYr246: {	/* io1 :  iofmove SPOWER */
#line 1094 "gram.in"
 ioclause(IOSUNIT, IOSTDERR); endioctl(); 
} break;

case YYr248: {	/* io1 :  read ioctl */
#line 1097 "gram.in"
 doio(CHNULL); 
} break;

case YYr249: {	/* io1 :  read infmt */
#line 1099 "gram.in"
 doio(CHNULL); 
} break;

case YYr250: {	/* io1 :  read ioctl inlist */
#line 1101 "gram.in"
 doio(revchain(yypvt[0].chval)); 
} break;

case YYr251: {	/* io1 :  read infmt SCOMMA inlist */
#line 1103 "gram.in"
 doio(revchain(yypvt[0].chval)); 
} break;

case YYr252: {	/* io1 :  read ioctl SCOMMA inlist */
#line 1105 "gram.in"
 doio(revchain(yypvt[0].chval)); 
} break;

case YYr253: {	/* io1 :  write ioctl */
#line 1107 "gram.in"
 doio(CHNULL); 
} break;

case YYr254: {	/* io1 :  write ioctl outlist */
#line 1109 "gram.in"
 doio(revchain(yypvt[0].chval)); 
} break;

case YYr255: {	/* io1 :  print */
#line 1111 "gram.in"
 doio(CHNULL); 
} break;

case YYr256: {	/* io1 :  print SCOMMA outlist */
#line 1113 "gram.in"
 doio(revchain(yypvt[0].chval)); 
} break;

case YYr258: {	/* fmkwd :  SBACKSPACE */
#line 1120 "gram.in"
 iostmt = IOBACKSPACE; 
} break;

case YYr259: {	/* fmkwd :  SREWIND */
#line 1122 "gram.in"
 iostmt = IOREWIND; 
} break;

case YYr260: {	/* fmkwd :  SENDFILE */
#line 1124 "gram.in"
 iostmt = IOENDFILE; 
} break;

case YYr262: {	/* ctlkwd :  SINQUIRE */
#line 1131 "gram.in"
 iostmt = IOINQUIRE; 
} break;

case YYr263: {	/* ctlkwd :  SOPEN */
#line 1133 "gram.in"
 iostmt = IOOPEN; 
} break;

case YYr264: {	/* ctlkwd :  SCLOSE */
#line 1135 "gram.in"
 iostmt = IOCLOSE; 
} break;

case YYr265: {	/* infmt :  unpar_fexpr */
#line 1139 "gram.in"

		ioclause(IOSUNIT, ENULL);
		ioclause(IOSFMT, yypvt[0].expval);
		endioctl();
		
} break;

case YYr266: {	/* infmt :  SSTAR */
#line 1145 "gram.in"

		ioclause(IOSUNIT, ENULL);
		ioclause(IOSFMT, ENULL);
		endioctl();
		
} break;

case YYr267: {	/* ioctl :  SLPAR fexpr SRPAR */
#line 1153 "gram.in"

		  ioclause(IOSUNIT, yypvt[-1].expval);
		  endioctl();
		
} break;

case YYr268: {	/* ioctl :  SLPAR ctllist SRPAR */
#line 1158 "gram.in"
 endioctl(); 
} break;

case YYr271: {	/* ioclause :  fexpr */
#line 1166 "gram.in"
 ioclause(IOSPOSITIONAL, yypvt[0].expval); 
} break;

case YYr272: {	/* ioclause :  SSTAR */
#line 1168 "gram.in"
 ioclause(IOSPOSITIONAL, ENULL); 
} break;

case YYr273: {	/* ioclause :  SPOWER */
#line 1170 "gram.in"
 ioclause(IOSPOSITIONAL, IOSTDERR); 
} break;

case YYr274: {	/* ioclause :  nameeq expr */
#line 1172 "gram.in"
 ioclause(yypvt[-1].ival, yypvt[0].expval); 
} break;

case YYr275: {	/* ioclause :  nameeq SSTAR */
#line 1174 "gram.in"
 ioclause(yypvt[-1].ival, ENULL); 
} break;

case YYr276: {	/* ioclause :  nameeq SPOWER */
#line 1176 "gram.in"
 ioclause(yypvt[-1].ival, IOSTDERR); 
} break;

case YYr277: {	/* nameeq :  SNAMEEQ */
#line 1180 "gram.in"
 yyval.ival = iocname(); 
} break;

case YYr278: {	/* read :  SREAD end_spec in_ioctl */
#line 1184 "gram.in"
 iostmt = IOREAD; 
} break;

case YYr279: {	/* write :  SWRITE end_spec in_ioctl */
#line 1188 "gram.in"
 iostmt = IOWRITE; 
} break;

case YYr280: {	/* print :  SPRINT end_spec fexpr in_ioctl */
#line 1192 "gram.in"

		iostmt = IOWRITE;
		ioclause(IOSUNIT, ENULL);
		ioclause(IOSFMT, yypvt[-1].expval);
		endioctl();
		
} break;

case YYr281: {	/* print :  SPRINT end_spec SSTAR in_ioctl */
#line 1199 "gram.in"

		iostmt = IOWRITE;
		ioclause(IOSUNIT, ENULL);
		ioclause(IOSFMT, ENULL);
		endioctl();
		
} break;

case YYr282: {	/* inlist :  inelt */
#line 1208 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].tagval, CHNULL); 
} break;

case YYr283: {	/* inlist :  inlist SCOMMA inelt */
#line 1210 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].tagval, yypvt[-2].chval); 
} break;

case YYr284: {	/* inelt :  lhs */
#line 1214 "gram.in"
 yyval.tagval = (tagptr) yypvt[0].expval; 
} break;

case YYr285: {	/* inelt :  SLPAR inlist SCOMMA dospec SRPAR */
#line 1216 "gram.in"
 yyval.tagval = (tagptr) mkiodo(yypvt[-1].chval,revchain(yypvt[-3].chval)); 
} break;

case YYr286: {	/* outlist :  uexpr */
#line 1220 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].expval, CHNULL); 
} break;

case YYr287: {	/* outlist :  other */
#line 1222 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].tagval, CHNULL); 
} break;

case YYr289: {	/* out2 :  uexpr SCOMMA uexpr */
#line 1227 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].expval, mkchain((char *)yypvt[-2].expval, CHNULL) ); 
} break;

case YYr290: {	/* out2 :  uexpr SCOMMA other */
#line 1229 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].tagval, mkchain((char *)yypvt[-2].expval, CHNULL) ); 
} break;

case YYr291: {	/* out2 :  other SCOMMA uexpr */
#line 1231 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].expval, mkchain((char *)yypvt[-2].tagval, CHNULL) ); 
} break;

case YYr292: {	/* out2 :  other SCOMMA other */
#line 1233 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].tagval, mkchain((char *)yypvt[-2].tagval, CHNULL) ); 
} break;

case YYr293: {	/* out2 :  out2 SCOMMA uexpr */
#line 1235 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].expval, yypvt[-2].chval); 
} break;

case YYr294: {	/* out2 :  out2 SCOMMA other */
#line 1237 "gram.in"
 yyval.chval = mkchain((char *)yypvt[0].tagval, yypvt[-2].chval); 
} break;

case YYr295: {	/* other :  complex_const */
#line 1241 "gram.in"
 yyval.tagval = (tagptr) yypvt[0].expval; 
} break;

case YYr296: {	/* other :  SLPAR expr SRPAR */
#line 1243 "gram.in"
 yyval.tagval = (tagptr) yypvt[-1].expval; 
} break;

case YYr297: {	/* other :  SLPAR uexpr SCOMMA dospec SRPAR */
#line 1245 "gram.in"
 yyval.tagval = (tagptr) mkiodo(yypvt[-1].chval, mkchain((char *)yypvt[-3].expval, CHNULL) ); 
} break;

case YYr298: {	/* other :  SLPAR other SCOMMA dospec SRPAR */
#line 1247 "gram.in"
 yyval.tagval = (tagptr) mkiodo(yypvt[-1].chval, mkchain((char *)yypvt[-3].tagval, CHNULL) ); 
} break;

case YYr299: {	/* other :  SLPAR out2 SCOMMA dospec SRPAR */
#line 1249 "gram.in"
 yyval.tagval = (tagptr) mkiodo(yypvt[-1].chval, revchain(yypvt[-3].chval)); 
} break;

case YYr300: {	/* in_ioctl :  */
#line 1253 "gram.in"
 startioctl(); 
} break;
#line 237 "/etc/yyparse.c"
	case YYrACCEPT:
		YYACCEPT;
	case YYrERROR:
		goto yyError;
#ifdef YYLR2
	case YYrLR2:
#ifndef YYSYNC
		YYREAD;
#endif
		yyj = 0;
		while(yylr2[yyj] >= 0) {
			if(yylr2[yyj] == yystate && yylr2[yyj+1] == yychar
			&& yylook(yys+1,yyps,yystate,yychar,yy2lex(),yylr2[yyj+2]))
					break;
			yyj += 3;
		}
		if(yylr2[yyj] < 0)
			goto yyError;
		if(yylr2[yyj+2] < 0) {
			yystate = ~ yylr2[yyj+2];
			goto yyStack;
		}
		yyi = yylr2[yyj+2];
		goto yyReduce;
#endif
	}

	/*
	 *	Look up next state in goto table.
	 */

	yyp = &yygo[yypgo[yyi]];
	yyq = yyp++;
	yyi = *yyps;
#if	0 && defined(__TURBOC__) && __SMALL__
	/* THIS ONLY WORKS ON TURBO C 1.5 !!! */
	/* yyi is in di, yyp is in si */
L02:
	asm lodsw		/* ax = *yyp++; */
	asm cmp yyi, ax
	asm jl L02
#else
	while (yyi < *yyp++)
		;
#endif
	yystate = ~(yyi == *--yyp? YYQYYP: *yyq);
	goto yyStack;

yyerrlabel:	;		/* come here from YYERROR	*/
/*
#pragma used yyerrlabel
 */
	yyerrflag = 1;
	if (yyi == YYrERROR)
		yyps--, yypv--;
	
yyError:
	switch (yyerrflag) {

	case 0:		/* new error */
		yynerrs++;
		yyi = yychar;
		yyerror("Syntax error");
		if (yyi != yychar) {
			/* user has changed the current token */
			/* try again */
			yyerrflag++;	/* avoid loops */
			goto yyEncore;
		}

	case 1:		/* partially recovered */
	case 2:
		yyerrflag = 3;	/* need 3 valid shifts to recover */
			
		/*
		 *	Pop states, looking for a
		 *	shift on `error'.
		 */

		for ( ; yyps > yys; yyps--, yypv--) {
			if (*yyps >= sizeof yypact/sizeof yypact[0])
				continue;
			yyp = &yyact[yypact[*yyps]];
			yyq = yyp;
			do
				;
			while (YYERRCODE < *yyp++);
			if (YYERRCODE == yyp[-1]) {
				yystate = ~YYQYYP;
				goto yyStack;
			}
				
			/* no shift in this state */
#if YYDEBUG
			if (yydebug && yyps > yys+1)
				printf(
	gettext("Error recovery pops state %d (%d), uncovers %d (%d)\n"),
					yysmap[yyps[0]], yyps[0],
					yysmap[yyps[-1]], yyps[-1]);
#endif
			/* pop stacks; try again */
		}
		/* no shift on error - abort */
		break;

	case 3:
		/*
		 *	Erroneous token after
		 *	an error - discard it.
		 */

		if (yychar == 0)  /* but not EOF */
			break;
#if YYDEBUG
		if (yydebug)
			printf(gettext("Error recovery discards %s (%d), "),
				yyptok(yychar), yychar);
#endif
		yyclearin;
		goto yyEncore;	/* try again in same state */
	}
	YYABORT;

#ifdef YYALLOC
yyReturn:
	yylval = save_yylval;
	yyval = save_yyval;
	yypvt = save_yypvt;
	yychar = save_yychar;
	yyerrflag = save_yyerrflag;
	yynerrs = save_yynerrs;
	free((char *)yys);
	free((char *)yyv);
	return(retval);
#endif
}

#ifdef YYLR2
yylook(s,rsp,state,c1,c2,i)
short *s;		/* stack		*/
short *rsp;		/* real top of stack	*/
int state;		/* current state	*/
int c1;			/* current char		*/
int c2;			/* next char		*/
int i;			/* action S < 0, R >= 0	*/
{
	int j;
	short *p,*q;
	short *sb,*st;
#if YYDEBUG
	if(yydebug) {
	printf(gettext("LR2 state %d (%d) char %s (%d) lookahead %s (%d)"),
			yysmap[state],state,yyptok(c1),c1,yyptok(c2),c2);
		if(i > 0)
			printf(gettext("reduce %d (%d)\n"), yyrmap[i], i);
		else
			printf(gettext("shift %d (%d)\n"), yysmap[i], i);
	}
#endif
	st = sb = rsp+1;
	if(i >= 0)
		goto reduce;
  shift:
	state = ~i;
	c1 = c2;
	if(c1 < 0)
		return 1;
	c2 = -1;

  stack:
  	if(++st >= &s[YYSSIZE]) {
		yyerror("Parser Stack Overflow");
		return 0;
	}
	*st = state;
	if(state >= sizeof yypact/sizeof yypact[0])
		i = state- YYDELTA;
	else {
		p = &yyact[yypact[state]];
		q = p;
		i = c1;
		while(i < *p++)
			;
		if(i == p[-1]) {
			state = ~q[q-p];
			c1 = c2;
			if(c1 < 0)
				return 1;
			c2 = -1;
			goto stack;
		}
		if(state >= sizeof yydef/sizeof yydef[0])
			return 0;
		if((i = yydef[state]) < 0) {
			p = &yyex[~i];
			while((i = *p) >= 0 && i != c1)
				p += 2;
			i = p[1];
		}
	}
  reduce:
  	j = yyrlen[i];
	if(st-sb >= j)
		st -= j;
	else {
		rsp -= j+st-sb;
		st = sb;
	}
	switch(i) {
	case YYrERROR:
		return 0;
	case YYrACCEPT:
		return 1;
	case YYrLR2:
		j = 0;
		while(yylr2[j] >= 0) {
			if(yylr2[j] == state && yylr2[j+1] == c1)
				if((i = yylr2[j+2]) < 0)
					goto shift;
				else
					goto reduce;
		}
		return 0;
	}
	p = &yygo[yypgo[i]];
	q = p++;
	i = st==sb ? *rsp : *st;
	while(i < *p++);
	state = ~(i == *--p? q[q-p]: *q);
	goto stack;
}
#endif
		
#if YYDEBUG
	
/*
 *	Print a token legibly.
 *	This won't work if you roll your own token numbers,
 *	but I've found it useful.
 */
char *
yyptok(i)
{
	static char	buf[10];

	if (i >= YYERRCODE)
		return yystoken[i-YYERRCODE];
	if (i < 0)
		return "";
	if (i == 0)
		return "$end";
	if (i < ' ')
		sprintf(buf, "'^%c'", i+'@');
	else
		sprintf(buf, "'%c'", i);
	return buf;
}
#endif
#if YYDEBUG
char * yystoken[] = {
	"error",
	0
};
char * yysvar[] = {	"$accept",
	"program",
	"thislabel",
	"label",
	"assignlabel",
	"other",
	"inelt",
	"type",
	"typespec",
	"typename",
	"dcl",
	"letter",
	"addop",
	"relop",
	"stop",
	"nameeq",
	"lengspec",
	"filename",
	"datavar",
	"datavarlist",
	"namelistlist",
	"funarglist",
	"funargs",
	"dospec",
	"dospecw",
	"callarglist",
	"arglist",
	"args",
	"exprlist",
	"inlist",
	"outlist",
	"out2",
	"substring",
	"name",
	"arg",
	"call",
	"var",
	"lhs",
	"expr",
	"uexpr",
	"opt_expr",
	"fexpr",
	"unpar_fexpr",
	"ubound",
	"simple",
	"value",
	"callarg",
	"complex_const",
	"simple_const",
	"bit_const",
	"common",
	"comblock",
	"entryname",
	"progname",
	"equivlist",
	"stat",
	"entry",
	"spec",
	"exec",
	"end_spec",
	"new_proc",
	"progarglist",
	"progargs",
	"progarg",
	"external",
	"intrinsic",
	"equivalence",
	"data",
	"implicit",
	"namelist",
	"savelist",
	"in_dcl",
	"paramlist",
	"opt_comma",
	"new_dcl",
	"dims",
	"datainit",
	"vallist",
	"intonlyon",
	"intonlyoff",
	"equivset",
	"in_data",
	"datalist",
	"datapop",
	"$90",
	"val",
	"saveitem",
	"paramitem",
	"dimlist",
	"$112",
	"dim",
	"labellist",
	"implist",
	"imptype",
	"letgroups",
	"$126",
	"letgroup",
	"namelistentry",
	"iffable",
	"logif",
	"let",
	"goto",
	"io",
	"io1",
	"iofmove",
	"ioctl",
	"iofctl",
	"read",
	"infmt",
	"write",
	"print",
	"fmkwd",
	"in_ioctl",
	"ctlkwd",
	"ctllist",
	"ioclause",
	0
};
short yyrmap[] = {
	 301,  302,  303,   11,   21,   29,   45,   46,   66,  104, 
	 110,  125,  130,  135,  139,  140,  141,  142,  148,  149, 
	 150,  151,  152,  153,  154,  155,  156,  157,  158,  159, 
	 168,  170,  173,  192,  193,  194,  195,  196,  197,  208, 
	 211,  217,  225,  227,  237,  238,  244,  248,  249,  250, 
	 251,  252,  253,  255,  265,  271,  274,  286,  287,  289, 
	 291,  293,  295,  296,  300,  299,  298,  297,  294,  292, 
	 290,  285,  284,  283,  282,  281,  280,  279,  278,  277, 
	 276,  275,  273,  272,  268,  267,  266,  264,  263,  262, 
	 260,  259,  258,  256,  254,  246,  245,  242,  241,  240, 
	 239,  236,  235,  234,  232,  231,  230,  226,  224,  223, 
	 222,  221,  220,  219,  218,  216,  215,  212,  210,  207, 
	 206,  205,  204,  202,  201,  200,  199,  189,  187,  186, 
	 185,  184,  182,  181,  180,  179,  178,  177,  175,  172, 
	 171,  169,  167,  166,  165,  164,  163,  162,  161,  160, 
	 144,  138,  137,  136,  132,  131,  126,  122,  121,  120, 
	 119,  117,  116,  115,  112,  109,  108,  107,  106,  105, 
	 100,   96,   94,   93,   90,   89,   88,   87,   86,   83, 
	  82,   81,   78,   77,   76,   75,   74,   73,   72,   71, 
	  70,   69,   68,   67,   65,   64,   63,   62,   61,   60, 
	  59,   58,   57,   56,   55,   54,   53,   52,   51,   50, 
	  49,   48,   47,   36,   35,   34,   33,   32,   31,   30, 
	  20,   19,   18,   17,   16,   15,   14,   13,   12,   10, 
	   9,    8,    7,    6,    5,    3,    1,    2,    4,   22, 
	  23,   24,   25,   26,   28,   79,   80,   84,   85,   91, 
	  92,   95,   97,   98,   99,  101,  102,  103,  111,  113, 
	 114,  123,  124,  127,  128,  129,  133,  134,  143,  145, 
	 146,  147,  176,  183,  188,  190,  191,  198,  203,  209, 
	 213,  214,  229,  243,  247,  257,  261,  269,  270,  288, 
	 233,  228,  174,  118,   44,   43,   42,   41,   40,   39, 
	  38,   37,   27,    0
};
short yysmap[] = {
	   1,    7,    8,   12,   16,   17,   25,   26,   27,   28, 
	  30,   31,   32,   33,   36,   37,   39,   40,   41,   42, 
	  45,   50,   51,   52,   53,   66,   67,   69,   70,   71, 
	  72,   73,   74,   75,   76,   77,   79,   81,   82,   83, 
	  85,   93,   94,   95,   98,  100,  101,  107,  118,  126, 
	 131,  132,  144,  159,  162,  164,  168,  170,  173,  175, 
	 178,  179,  183,  184,  191,  192,  199,  201,  208,  215, 
	 216,  222,  223,  227,  231,  240,  250,  258,  272,  274, 
	 277,  279,  280,  283,  289,  290,  310,  314,  318,  320, 
	 322,  323,  324,  325,  326,  327,  330,  331,  336,  342, 
	 362,  372,  379,  386,  388,  389,  390,  391,  392,  393, 
	 394,  395,  396,  397,  398,  401,  404,  406,  409,  410, 
	 412,  424,  426,  442,  449,  457,  459,  464,  467,  470, 
	 472,  476,  480,  481,  488,  491,  496,  497,  504,  514, 
	 534,  537,  539,  533,  524,  523,  522,  518,  516,  506, 
	 505,  501,  499,  494,  486,  484,  483,  482,  479,  477, 
	 475,  473,  469,  468,  466,  465,  463,  461,  455,  452, 
	 448,  444,  439,  438,  436,  435,  434,  432,  430,  429, 
	 428,  423,  422,  421,  418,  416,  414,  413,  411,  407, 
	 402,  400,  399,  382,  376,  371,  370,  369,  368,  365, 
	 363,  361,  357,  355,  353,  351,  347,  345,  344,  343, 
	 341,  340,  338,  335,  334,  332,  329,  328,  321,  319, 
	 315,  311,  309,  308,  307,  306,  305,  304,  303,  302, 
	 301,  300,  299,  298,  297,  288,  287,  286,  278,  275, 
	 265,  264,  263,  262,  261,  259,  254,  252,  249,  248, 
	 247,  246,  245,  244,  243,  241,  238,  236,  233,  226, 
	 221,  220,  219,  218,  217,  214,  211,  210,  207,  203, 
	 200,  196,  195,  194,  185,  177,  176,  174,  171,  169, 
	 167,  166,  165,  160,  157,  153,  150,  149,  148,  147, 
	 141,  138,  137,  136,  134,  133,  130,  129,  128,  127, 
	 106,  103,  102,   97,   96,   91,   86,   78,   43,   38, 
	  21,   20,   19,   18,    5,    4,   92,  508,  509,  510, 
	 385,  387,  403,  512,  212,  408,  213,  284,  285,  187, 
	 188,  202,  312,  313,  204,  205,  316,  317,   99,    9, 
	  10,   11,   13,   14,   15,  193,  209,  123,  124,   22, 
	 349,  151,    6,   23,   24,  337,  417,  237,  225,  515, 
	 228,   29,  242,  230,  235,  339,  239,  540,   34,  419, 
	 517,  420,  139,  140,  478,  143,   44,  348,  519,  384, 
	 108,  109,  110,  511,  112,  113,  114,  115,  116,  117, 
	 446,  513,  471,  224,  291,  292,  293,  294,  295,  296, 
	 119,  120,  415,   48,  527,  441,  425,  520,  145,  251, 
	 229,  474,  333,  490,  538,  492,  358,  487,  352,  535, 
	 354,  359,  155,  500,  529,  450,  273,  431,  146,  536, 
	  49,  489,  356,  433,  269,  256,  270,  257,  366,  158, 
	 271,  443,  360,  260,  526,  437,   54,   55,   56,   57, 
	  58,   59,   60,   61,   62,   63,   64,   65,  152,  378, 
	 453,  454,  530,  440,   68,  181,  373,  374,  503,  375, 
	 456,  377,  121,  172,   80,  276,  458,  380,  381,  282, 
	 383,    2,    3,   84,  180,  182,   87,   89,    0,   90, 
	  88,  281,  462,  507,  460,  532,  531,  255,  268,  253, 
	 267,  451,  502,  528,  447,  156,  367,  154,  364,  498, 
	 495,  493,  525,  266,  485,  350,  427,  521,   47,  161, 
	 234,  232,  198,  197,  445,  111,  186,  105,  104,   46, 
	 142,  346,  135,   35,  163,  125,  122,  190,  189,  206,  405
};
int yyntoken = 101;
int yynvar = 116;
int yynstate = 541;
int yynrule = 304;
#endif
